#ifndef _COMMON_H_
#define _COMMON_H_

// draw grahpics number definitions
#define	GNUM_TYPE1			0
#define	GNUM_TYPE2			1
#define	GNUM_TYPE3			2

// draw funtion.
void loadImage(CMoso *pMe,Image* bm, char* pszBarFile,int resID);
void freeImage(CMoso *pMe,Image* bm);
void setScreen(CMoso* pMe); // setClip(pMe,0,0,pMe->canvas_width,pMe->canvas_height);
void setClip(CMoso *pMe,int x, int y, int w, int h);

void drawImage(CMoso *pMe,int resID, int x, int y, int flag);
void drawImage2(CMoso *pMe, Image* bm, int x, int y, int flag);

void fillRect(CMoso* pMe,int x,int y,int width,int height,RGBVAL rgb);
void drawRect(CMoso* pMe,int x,int y,int width,int height,RGBVAL rgb);
void drawString(CMoso *pMe,char* str,int x, int y,int flag);
void drawWString(CMoso *pMe,AECHAR* str,int x, int y,int flag);
void StrToWStr(char* src,AECHAR* dst);
void setColor(CMoso *pMe,uint8 r,uint8 g,uint8 b);
//int  CharAt(const char* p,char key,int nth);
void debugText(CMoso* pMe, const char* text);

void drawCut(CMoso* pMe,int resID, int x, int y, int row, int col, int xsize, int ysize);
void drawGNumber(CMoso *pMe,int num,int x,int y,int type);


// text draw
void initText(CMoso* pMe,char* sbText,int dx,int dy,int flag);
void drawText(CMoso* pMe,int x,int y,int dx,int dy,boolean showPage);
void stopText(CMoso* pMe);

void initAnitext(CMoso* pMe,char* sbText,int timegap,int dx,int flag);
boolean drawAnitext(CMoso* pMe,int x,int y,int dx,int dy);
void stopAnitext(CMoso* pMe);


int getRand(CMoso* pMe,int maxNum);


// related draw guage.
void setGauge(CMoso* pMe,int x,int y,int max,int resId,int resbgId,int d);
void drawGauge(CMoso* pMe,int gauge,int seq);
void releaseGauge(CMoso* pMe);



void LogHeapStatsToFile(CMoso *pMe, int i);


#endif // _COMMON_H_