#include "moso.h"
#include "find.h"
#include "dig.h"
#include "menu.h"
#include "happysnd.h"
#include "save.h"

void findTick(CMoso* pMe)
{
	// 丮  ..
	if( pMe->gameMode == GAMEMODE_STORY )
	{
		// ù̸ Ʃ丮 ش.
		if( pMe->story_findstage == 0 && pMe->tutorial_findShowed == FALSE)
		{
			pMe->tutorial_findShowed = TRUE;
			SETSTATE(pMe,STATE_TUTORIAL);
			return;
		}
	}

	//  ޴ ȣ (  ð   ʴٸ..    ٸ Ű Է  ʴ´.)
	if( pMe->keyCurr & GKEY_BACK && pMe->find_state != FSTATE_END)
	{
		gotoMenu(pMe,MSTATE_GAMEMENU);
		SETSTATE(pMe,STATE_MENU);

		// ⼭ FALSE   ƿ  ٽ ׷..
		pMe->find_backDraw = FALSE;

		pMe->keyCurr = GKEY_NONE;
		return;
	}

#if CHEAT_ENDLESS_LEVELJUMP
	if( pMe->gameMode == GAMEMODE_ENDLESS) 
	{
		// Ѹ_ġƮŰ   ׳ ö󰡹.
		if( pMe->keyCurr & GKEY_SOFT3 )
		{					
			pMe->endless_findlv++;

			if( pMe->endless_findlv < ENDLESS_LEVELEND ) 
			{
				findInit(pMe);
				gotoFind(pMe,FSTATE_READY);
			}
			else 
			{
				pMe->endless_findlv = 0;

				gotoMenu(pMe,MSTATE_MAIN);
				SETSTATE(pMe,STATE_MENU);
			}
		}
	}
#endif

	switch(pMe->find_state)
	{
		case FSTATE_READY:
			{
				uint32	tickTime;
				int x,y,dx,dy;

				setScreen(pMe);
				findDrawBg(pMe);
				findDrawRemaincha(pMe);
				findDrawTime(pMe);				
				findDrawDay(pMe);
				findDrawScore(pMe);


				tickTime = GET_UPTIMEMS();

				//  ó  ƴ϶ ð  Ų.
				if( pMe->find_startTime != 0 )
					pMe->find_currTime = tickTime - pMe->find_startTime;

				// ŸӿǾٸ..
				if( pMe->find_currTime > pMe->find_wholeTime )
				{
					gotoFind(pMe,FSTATE_RESULT);
					break;
				}


				x = pMe->canvas_midx;
				y = pMe->canvas_midy;

				dx = pMe->imgGame[IMG_START].info.cx;
				dy = pMe->imgGame[IMG_START].info.cy;

				if( pMe->find_ready == FALSE )
				{
					pMe->find_temp		= tickTime;
					pMe->find_ready		= TRUE;
					pMe->find_startAni	= 1;
					break;
				}
				if( tickTime - pMe->find_temp > 300 && pMe->find_startAni == 1 )
				{
					pMe->find_temp		= tickTime;
					pMe->find_startAni	= 2;

					setClip(pMe,x-dx/2,y-dy/2,dx,dy);					
					drawImage(pMe,IMG_START,pMe->canvas_midx,pMe->canvas_midy,GFX_CENTER);			
				}
				else if( tickTime - pMe->find_temp > 300 && pMe->find_startAni == 2 )
				{
					pMe->find_temp		= tickTime;
					pMe->find_startAni	= 3;

					setClip(pMe,x-dx/2,y-dy/2,dx,dy);					
					pMe->find_backDraw = FALSE;
					findDrawBg(pMe);
				}
				else if( tickTime - pMe->find_temp > 300 && pMe->find_startAni == 3 )
				{
					pMe->find_temp		= tickTime;
					pMe->find_startAni	= 4;

					setClip(pMe,x-dx/2,y-dy/2,dx,dy);					
					drawImage(pMe,IMG_START,pMe->canvas_midx,pMe->canvas_midy,GFX_CENTER);			
				}
				else if( tickTime - pMe->find_temp > 300 && pMe->find_startAni == 4 )
				{
					pMe->find_temp		= tickTime;
					pMe->find_startAni	= 5;

					setClip(pMe,x-dx/2,y-dy/2,dx,dy);					
					pMe->find_backDraw = FALSE;
					findDrawBg(pMe);
				}
				else if( pMe->find_startAni == 5 )
				{
					gotoFind(pMe,FSTATE_START);
				}
			}
			break;

		case FSTATE_START:
			{
				uint32 tickTime;
				int	who;
				int	i;


				setScreen(pMe);
				findDrawBg(pMe);
				findDrawScore(pMe);
				//findDrawTime(pMe);
				findDrawDay(pMe);


				tickTime = GET_UPTIMEMS();

				//  ó ۽..
				if( pMe->find_startTime == 0 )
					pMe->find_startTime = tickTime;


				// get current time
				pMe->find_currTime = tickTime - pMe->find_startTime;


				// ŸӿǾٸ..
				if( pMe->find_currTime > pMe->find_wholeTime )
				{
					gotoFind(pMe,FSTATE_RESULT);
					break;
				}

				findDrawTime(pMe);

				//  ֱ
				//   ٸ ð   break.
				if( pMe->find_moved == FALSE )
				{
					pMe->find_temp = tickTime;
					pMe->find_moved = TRUE;
					pMe->find_moveOnce	= FALSE;
					break;
				}
				// ˼ ̱
				if( tickTime - pMe->find_temp < pMe->find_moveGap )					
				{
					if(	pMe->find_moveOnce == FALSE )
					{
						pMe->find_moveOnce = TRUE;
//						DBGPRINTF("˼ ̱");

//						DBGPRINTF("tickTime - pMe->find_temp %d",tickTime - pMe->find_temp);

						
						if( pMe->find_iter == 0 )
						{
							pMe->find_spotStart = 0;
						}
						else 
						{
							pMe->find_spotStart += pMe->find_spot[pMe->find_iter-1];
						}

						pMe->find_spotEnd = pMe->find_spotStart + pMe->find_spot[pMe->find_iter];

					
						for(i=pMe->find_spotStart;i<pMe->find_spotEnd;i++)
						{
							who = pMe->find_seq[pMe->find_seqFlag][i];

							if( pMe->find_move[who] == 0 )
								findUpdateBg(pMe,who,FIND_STOP);
							else
								findUpdateBg(pMe,who,FIND_MOVE);
						}
					}
				}
				// ð   ..
				else
				{

//					DBGPRINTF(" \n");


					for(i=pMe->find_spotStart;i<pMe->find_spotEnd;i++)
					{
						who = pMe->find_seq[pMe->find_seqFlag][i];
						findUpdateBg(pMe,who,FIND_BLACK);
					}

					pMe->find_moved = FALSE;
					
					//    ÷ Űش.
					pMe->find_iter++;
					//  ٴٶٸ...
					if( pMe->find_iter == pMe->find_spotFlag )
					{
						pMe->find_temp = GET_UPTIMEMS();
						gotoFind(pMe,FSTATE_INPUT);
					}
				}

				// ڰ   Ű ٸ FSTATE_INPUT  Ѿ .
				if( pMe->keyCurr & GKEY_NUMBER )
				{
					// ȭ  ְ.
					setClip(pMe,0,0,pMe->canvas_width,pMe->find_remaincha_y);
					pMe->find_backDraw = FALSE;
					findDrawBg(pMe);	

					pMe->find_cutInput = TRUE;
					pMe->find_temp = GET_UPTIMEMS();
					gotoFind(pMe,FSTATE_INPUT);


					pMe->find_keyPrev = pMe->keyCurr;
				}


#if CHEAT_STORY_STAGECLEAR
				// ӽð Ҵµ  ߾ٸ .
				if( pMe->gameMode == GAMEMODE_STORY) 
				{
					if( pMe->keyCurr == GKEY_SOFT3 ) 
					{
						pMe->find_end = FALSE;
						pMe->find_currScore = 0;
						gotoFind(pMe,FSTATE_END);
					}
				}
#endif

			}
			break;

		case FSTATE_INPUT:
			{
				uint32 tickTime;
				int who = 0;

				//findDrawTime(pMe);

				tickTime = GET_UPTIMEMS();

				// get current time
				pMe->find_currTime = tickTime - pMe->find_startTime;				

				// ŸӿǾٸ..
				if( pMe->find_currTime > pMe->find_wholeTime )
				{
					gotoFind(pMe,FSTATE_RESULT);
					break;
				}

				findDrawTime(pMe);


				// ڰ  Է   Ű   ͼ ־ش.
				// loop  ɷִ GKEY_NONE  ⶧..
				if( pMe->find_cutInput == TRUE ) {
					pMe->find_cutInput = FALSE;
					pMe->keyCurr = pMe->find_keyPrev;
					pMe->find_keyPrev = GKEY_NONE;
				}
				// ѵ ð ȿ Է..
				if( tickTime - pMe->find_temp < 2000 )
				{									//
					if( pMe->keyCurr & GKEY_NUMBER )
					{
						//  ÷.
						sfx_play(pMe,SND_FINDSELECT,FALSE);

						if( pMe->keyCurr & GKEY_1 )				who = 0;
						else if( pMe->keyCurr & GKEY_2 )		who = 1;
						else if( pMe->keyCurr & GKEY_3 )		who = 2;
						else if( pMe->keyCurr & GKEY_4 )		who = 3;
						else if( pMe->keyCurr & GKEY_5 )		who = 4;
						else if( pMe->keyCurr & GKEY_6 )		who = 5;
						else if( pMe->keyCurr & GKEY_7 )		who = 6;
						else if( pMe->keyCurr & GKEY_8 )		who = 7;
						else if( pMe->keyCurr & GKEY_9 )		who = 8;


						// if answer is incorrect, just stop.
						if( pMe->find_move[who] == 0 )
						{
							pMe->find_answer = FALSE;

							findUpdateBg(pMe,who,FIND_STOP);
							gotoFind(pMe,FSTATE_RESULT);
						}
						else if( pMe->find_move[who] == 1 )
						{
							// ڰ  Է ߴٸ Է   2 ְ.
							pMe->find_move[who] = 2;

							//  ߾ٰ ǥش.
							pMe->find_right++;

							//  ĳʹ X ǥ ش.
							setClip(pMe,pMe->find_remaincha_x,pMe->find_remaincha_y,pMe->canvas_width,20);
							findDrawRemaincha(pMe);
							//fillRect(pMe,0,0,pMe->canvas_width,pMe->canvas_height,RGB(255,0,0));
							

							findUpdateBg(pMe,who,FIND_MOVE);

							//    ãҴٸ..
							if( pMe->find_right == pMe->find_moveMax )
							{
								//   Ѹ      ϴ ̴.
								pMe->endless_findscore += 100;

								pMe->find_answer = TRUE;
								pMe->find_currScore--; //  ߾ٸ.
								gotoFind(pMe,FSTATE_RESULT);
							}
							else
								pMe->find_answer = FALSE;
						}
					}
				}
				else
				{
					gotoFind(pMe,FSTATE_RESULT);
				}
			}
			break;

		case FSTATE_RESULT:
			{
				int x,y,dx,dy;
				uint32 tickTime;

				// get current time
				tickTime = GET_UPTIMEMS();
				pMe->find_currTime = tickTime - pMe->find_startTime;				

				//  ̶ ð  귯. ׷Ƿ ׷ְ..
				findDrawTime(pMe);
				
				if( pMe->find_end == FALSE )
				{
					pMe->find_temp = tickTime;
					pMe->find_end = TRUE;
					break;
				}

				//   ̶..
				if( pMe->find_currTime < pMe->find_wholeTime )
				{
					//  ð   ش.
					if( tickTime - pMe->find_temp < 1000 )
					{
						x = pMe->canvas_midx;
						y = pMe->canvas_midy;

						dx = pMe->imgGame[IMG_TXTSUCCESS].info.cx;
						dy = pMe->imgGame[IMG_TXTSUCCESS].info.cy;

						setClip(pMe,x-dx/2,y-dy/2,dx,dy);

						//  ߾ٸ..
						if( pMe->find_answer )
							drawImage(pMe,IMG_TXTSUCCESS,pMe->canvas_midx,pMe->canvas_midy,GFX_CENTER);
						else
							drawImage(pMe,IMG_TXTFAILURE,pMe->canvas_midx,pMe->canvas_midy,GFX_CENTER);				
					}
					else 
					{
						// ӽð Ҵµ  ߾ٸ .
						if( pMe->find_currScore == 0 )
							gotoFind(pMe,FSTATE_END);

						else
						{
							//  ѵ ð ȵƴٸ   ƴϹǷ reset Ѵ.
							if( pMe->find_currTime < pMe->find_wholeTime )
							{
								findReset(pMe);
								gotoFind(pMe,FSTATE_READY);
							}
							else
							{
								gotoFind(pMe,FSTATE_END);
							}
						}
					}
				}
				//  ٸ  ھ   ش.
				else
				{	
					// ð   ʿϴϱ ⼭ FALSE  Ѵ.
					pMe->find_end = FALSE;

					gotoFind(pMe,FSTATE_END);
				}
/*
						//  ѵ ðȿ  ߾ٸ..
						if( pMe->find_currScore == 0 )
							drawImage(pMe,IMG_TXTSUCCESS,pMe->canvas_midx,pMe->canvas_midy,GFX_CENTER);
						else
							drawImage(pMe,IMG_TXTFAILURE,pMe->canvas_midx,pMe->canvas_midy,GFX_CENTER);
*/
				




				/*
				//  ð   ش.
				if( tickTime - pMe->find_temp < 1000 )
				{
					//   ̶..
					if( pMe->find_currTime < pMe->find_wholeTime )
					{
						x = pMe->canvas_midx;
						y = pMe->canvas_midy;

						dx = pMe->imgGame[IMG_TXTSUCCESS].info.cx;
						dy = pMe->imgGame[IMG_TXTSUCCESS].info.cy;

						setClip(pMe,x-dx/2,y-dy/2,dx,dy);

						//  ߾ٸ..
						if( pMe->find_answer )
							drawImage(pMe,IMG_TXTSUCCESS,pMe->canvas_midx,pMe->canvas_midy,GFX_CENTER);
						else
							drawImage(pMe,IMG_TXTFAILURE,pMe->canvas_midx,pMe->canvas_midy,GFX_CENTER);				

						// ӽð Ҵµ  ߾ٸ .
						if( pMe->find_currScore == 0 )
							gotoFind(pMe,FSTATE_END);
					}
					//  ٸ  ھ   ش.
					else
					{
						//  ѵ ðȿ  ߾ٸ..
						if( pMe->find_currScore == 0 )
							drawImage(pMe,IMG_TXTSUCCESS,pMe->canvas_midx,pMe->canvas_midy,GFX_CENTER);
						else
							drawImage(pMe,IMG_TXTFAILURE,pMe->canvas_midx,pMe->canvas_midy,GFX_CENTER);
					}
				}
				else
				{
					//  ѵ ð ȵƴٸ   ƴϹǷ reset Ѵ.
					if( pMe->find_currTime < pMe->find_wholeTime )
					{
						findReset(pMe);
						gotoFind(pMe,FSTATE_READY);
					}
					else
					{
						gotoFind(pMe,FSTATE_END);
					}
				}	
				*/
			}
			break;

		case FSTATE_END:
			{
				int x,y,dx,dy;
				uint32 tickTime;

				// get current time
				tickTime = GET_UPTIMEMS();

				if( pMe->find_end == FALSE )
				{
					pMe->find_temp = tickTime;
					pMe->find_end = TRUE;
					break;
				}

				if( pMe->gameMode == GAMEMODE_STORY )
				{
					//  ð   ش.
					if( tickTime - pMe->find_temp < 3000 )
					{
						//    Ǹ  ƾ   ʿ䰡 ִ.
						findDrawBg(pMe);
						if( pMe->find_resultbackDraw == FALSE )
						{
							if( pMe->find_currScore == 0 ) { // ̼ Ŭ   ȭ
								int item;
								Image imgCircle,imgText,imgIcon;
								char temp1[20],temp2[20];

								// ⼭ weapon  power   ȹ ش.
								imgCircle.bitmap	= NULL;
								imgCircle.src		= NULL;
								imgText.bitmap		= NULL;
								imgText.src			= NULL;
								imgCircle.bitmap	= NULL;
								imgCircle.src		= NULL;
								imgIcon.bitmap		= NULL;
								imgIcon.src			= NULL;


								loadImage(pMe,&imgCircle,MOSO_RES_FILE,IDB_RESULTCIRCLE);
								if( pMe->select_mission == 0 ) { // mission  POWER	
									loadImage(pMe,&imgText,MOSO_RES_FILE,IDB_TXTPOWER);
									loadImage(pMe,&imgIcon,MOSO_RES_FILE,IDB_RESULTPOWER);	
									SPRINTF(temp1,"%s","ȶ Ŀ +3");
									SPRINTF(temp2,"%s","Ͽϴ.");
									pMe->story_power++;
								}
								else if( pMe->select_mission == 1 ) { // mission  WEAPON
									loadImage(pMe,&imgText,MOSO_RES_FILE,IDB_TXTWEAPON);
									loadImage(pMe,&imgIcon,MOSO_RES_FILE,IDB_RESULTWEAPON);	
									SPRINTF(temp1,"%s","ũ Ŀ +3");
									SPRINTF(temp2,"%s","Ͽϴ.");
		
									pMe->story_weapon++;
								}
								else if( pMe->select_mission == 2 ) { // mission  ITEM
									//   
									item = getRand(pMe,4);

									loadImage(pMe,&imgText,MOSO_RES_FILE,IDB_TXTITEM);
									loadImage(pMe,&imgIcon,MOSO_RES_FILE,IDB_RESULTITEM1+item);	
									if( item == 0 )		SPRINTF(temp1,"%s","ð ");
									else if( item == 1 )SPRINTF(temp1,"%s","帱 ");
									else if( item == 2 )SPRINTF(temp1,"%s","ź ");
									else if( item == 3 )SPRINTF(temp1,"%s"," ");									
									SPRINTF(temp2,"%s","ȹϿϴ.");
									

									//  ϳ ÷ֱ.
									pMe->story_item[pMe->story_itemNum] = item;
									pMe->story_itemNum++;
								}

								setScreen(pMe);

								// draw white rect
								x	= pMe->find_resultup_x-5;
								y	= pMe->find_resultup_y-5;
								dx	= pMe->find_resultup_dx+10;
								dy	= pMe->find_resultup_dy+pMe->find_resultdn_dy+10;					
								fillRect(pMe,x,y,dx,dy,RGB(255,255,255));

								// draw black rect
								x	= pMe->find_resultup_x;
								y	= pMe->find_resultup_y;
								dx	= pMe->find_resultup_dx;
								dy	= pMe->find_resultup_dy;					
								fillRect(pMe,x,y,dx,dy,RGB(0,0,0));

								// draw gray rect
								x	= pMe->find_resultdn_x;
								y	= pMe->find_resultdn_y;
								dx	= pMe->find_resultdn_dx;
								dy	= pMe->find_resultdn_dy;					
								fillRect(pMe,x,y,dx,dy,RGB(92,92,92));

								x	= pMe->find_resultup_x+pMe->find_resultup_dx;
								y	= pMe->find_resultup_y;
								drawImage2(pMe,&imgCircle,x,y,GFX_RIGHT|GFX_TOP);

								x	= pMe->find_resultup_x - 2;
								y	= pMe->find_resultup_y - 2;
								drawImage2(pMe,&imgText,x,y,GFX_LEFT|GFX_TOP);

								x	= pMe->find_resultup_x+pMe->find_resultup_dx + 2;
								y	= pMe->find_resultup_y - 2;
								drawImage2(pMe,&imgIcon,x,y,GFX_RIGHT|GFX_TOP);


								drawString(pMe,temp1,pMe->find_resultdn_x,pMe->find_resultdn_y,GFX_LEFT);
								drawString(pMe,temp2,pMe->find_resultdn_x,pMe->find_resultdn_y+pMe->font_h,GFX_LEFT);

								freeImage(pMe,&imgText);
								freeImage(pMe,&imgCircle);
								freeImage(pMe,&imgIcon);							
							}

							else {	// ̼     ȭ.
								Image img;
								img.bitmap	= NULL;
								img.src		= NULL;

								setScreen(pMe);
								x	= pMe->find_resultup_x-5;
								y	= pMe->find_resultup_y-5;
								dx	= pMe->find_resultup_dx+10;
								dy	= pMe->find_resultup_dy+pMe->find_resultdn_dy+10;
								fillRect(pMe,x,y,dx,dy,RGB(255,255,255));


								x	= pMe->find_resultup_x;
								y	= pMe->find_resultup_y;
								dx	= pMe->find_resultup_dx;
								dy	= pMe->find_resultup_dy+pMe->find_resultdn_dy;
								fillRect(pMe,x,y,dx,dy,RGB(0,0,0));


								x	= (x + dx)/2;
								y	= (y + dy)/2;
								loadImage(pMe,&img,MOSO_RES_FILE,IDB_TXTMISSIONFAIL);								
								drawImage2(pMe,&img,x,y,GFX_CENTER);
								freeImage(pMe,&img);								
							}
							pMe->find_resultbackDraw = TRUE;
						}
					}
					else //    ־ٸ.
					{
						//  Ѱ ÷ ش.
						// ⼭  ʰ ߿ ı   ش.
						pMe->story_findstage++;

						//    ̼ Ŭ   ۿ   episode  ش.
						if( pMe->find_currScore == 0 && pMe->select_mission == 2)
						{
							int item = pMe->story_item[pMe->story_itemNum-1];

							if( item == 0 )		episodeInit(pMe,11);	// ð
							else if( item == 1 )episodeInit(pMe,12);	// 帱
							else if( item == 2 )episodeInit(pMe,13);	// ź
							else if( item == 3 )episodeInit(pMe,14);	// 							
							SETSTATE(pMe,STATE_EPISODE);
						}
						// ƴ  ı Ѿ.
						else 
						{
							SETSTATE(pMe,STATE_NIGHTEPISODE);
						}
					}

					findDrawScore(pMe);
					findDrawTime(pMe);
					findDrawDay(pMe);
				}
				else if( pMe->gameMode == GAMEMODE_ENDLESS )
				{
					//  ð   ش.
					if( tickTime - pMe->find_temp < 1000 )
					{
						x = pMe->canvas_midx;
						y = pMe->canvas_midy;

						dx = pMe->imgGame[IMG_TXTSUCCESS].info.cx;
						dy = pMe->imgGame[IMG_TXTSUCCESS].info.cy;

						setClip(pMe,x-dx/2,y-dy/2,dx,dy);

						//  ߾ٸ..
						if( pMe->find_answer )
							drawImage(pMe,IMG_TXTSUCCESS,pMe->canvas_midx,pMe->canvas_midy,GFX_CENTER);
						else
							drawImage(pMe,IMG_TXTFAILURE,pMe->canvas_midx,pMe->canvas_midy,GFX_CENTER);				
					}					
					else 
					{
						// ߴٸ..
						if( pMe->find_currScore == 0  )
						{
							// level ̰
							pMe->endless_findlv++;

							//  ϰ.
							saveData(pMe);

							//     ٸ. ޴ .
							if( pMe->endless_findlv == ENDLESS_LEVELEND ) // ⿡   ϸ ǰ..
							{
								pMe->endless_findlv = 0;
								saveData(pMe);

								// ŷ  Ȯâ .
								gotoMenu(pMe,MSTATE_PUTRANKINGCONFIRM);
								SETSTATE(pMe,STATE_MENU);
							}
							else
							{
								findInit(pMe);
								gotoFind(pMe,FSTATE_READY);
							}
						}
						// ߴٸ ޴ .
						else
						{
							// ŷ  Ȯâ .
							gotoMenu(pMe,MSTATE_PUTRANKINGCONFIRM);
							SETSTATE(pMe,STATE_MENU);
						}
					}
				}
			}
			break;
	}

	pMe->keyCurr = GKEY_NONE;
}

void findDraw(CMoso* pMe)
{
	switch(pMe->find_state)
	{
		case FSTATE_READY:
			break;
		case FSTATE_START:
			break;
		case FSTATE_INPUT:
			break;
		case FSTATE_RESULT:
			break;
		case FSTATE_END:
			break;
	}
}


void findInit(CMoso* pMe)
{
	int gap_x,gap_y,i;
	int dx,dy;

	int lv,weight;

	//  ʱȭ
	pMe->endless_findscore	= 0;

	// level value setting
	switch(pMe->gameMode)
	{
		case GAMEMODE_STORY:
			lv = pMe->story_findstage;
			if( lv > 14 ) lv = 14;

			pMe->find_wholeTime		= pMe->story_findFactor[lv][FIND_WHOLETIME];
			pMe->find_moveGap		= pMe->story_findFactor[lv][FIND_MOVEGAP];			
			pMe->find_inputTime		= pMe->story_findFactor[lv][FIND_INPUTTIME];	
			pMe->find_moveMax		= pMe->story_findFactor[lv][FIND_MOVEMAX];
			pMe->find_spotMax		= pMe->story_findFactor[lv][FIND_SPOTMAX];
			pMe->find_destScore		= pMe->story_findFactor[lv][FIND_DESTSCORE];
			break;

		case GAMEMODE_ENDLESS:
			weight	= (int)(pMe->endless_findlv / 30);
			lv		= pMe->endless_findlv % 30;

			if( pMe->endless_findlv < 90 )
			{
				pMe->find_wholeTime		= pMe->endless_findFactor[lv][FIND_WHOLETIME];
				pMe->find_moveGap		= pMe->endless_findFactor[lv][FIND_MOVEGAP];			
				pMe->find_inputTime		= pMe->endless_findFactor[lv][FIND_INPUTTIME];	
				pMe->find_moveMax		= pMe->endless_findFactor[lv][FIND_MOVEMAX];
				pMe->find_spotMax		= pMe->endless_findFactor[lv][FIND_SPOTMAX];
				pMe->find_destScore		= pMe->endless_findFactor[lv][FIND_DESTSCORE];
				pMe->find_destScore		+= weight;	// 30  ư ġ ش.
			}
			// 90 ~ 100      10 ÷ ϰ Ѵ.
			else
			{
				//     10 ÷ Ѵ.
				pMe->find_wholeTime		= pMe->endless_findFactor[29][FIND_WHOLETIME];
				pMe->find_moveGap		= pMe->endless_findFactor[29][FIND_MOVEGAP];			
				pMe->find_inputTime		= pMe->endless_findFactor[29][FIND_INPUTTIME];	
				pMe->find_moveMax		= pMe->endless_findFactor[29][FIND_MOVEMAX];
				pMe->find_spotMax		= pMe->endless_findFactor[29][FIND_SPOTMAX];
				pMe->find_destScore		= pMe->endless_findFactor[29][FIND_DESTSCORE];
				pMe->find_destScore		+= weight;
			}			
			break;
	}

#if CHEAT_ENDLESS_ONESECOND
	pMe->find_wholeTime = CHEAT_ENDLESS_ONESECOND;
#endif


	pMe->find_currTime		= 0;
	pMe->find_startTime		= 0;

	pMe->find_currScore		= pMe->find_destScore;

	// set character's position
	if( pMe->canvas_height < 160 )
	{
		dy = pMe->imgGame[IMG_FINDCHECK].info.cy;
		gap_x = pMe->canvas_width/3;
		gap_y = (pMe->canvas_height-STATUS_HEIGHT-dy)/3;
		for(i=0;i<9;i++)
		{
			pMe->find_x[i]	= gap_x * (i%3) + (gap_x/2);
			pMe->find_y[i]	= gap_y * (i/3) + (gap_y/2);
		}
	}
	else
	{
		dy = pMe->imgGame[IMG_FINDCHECK].info.cy;
		gap_x = 128/3;
		gap_y = (144-STATUS_HEIGHT-dy)/3;
		for(i=0;i<9;i++)
		{
			pMe->find_x[i]	= 25 + gap_x * (i%3) + (gap_x/2);
			pMe->find_y[i]	= 40 + gap_y * (i/3) + (gap_y/2);
		}
	}

	//    .
	findGetNonoverlapRand(pMe);



	// ġ ġ , 곻  ķ ̹ Ѵ.
	dx = pMe->imgGame[IMG_NUMBER2].info.cx/10;
	dy = pMe->imgGame[IMG_NUMBER2].info.cy;
	pMe->find_exval_x		= pMe->canvas_width;
	pMe->find_exval_y		= pMe->canvas_height - STATUS_HEIGHT - dy - 1;
	pMe->find_ex_x			= pMe->find_exval_x - dx*2 - 1;
	pMe->find_ex_y			= pMe->canvas_height - STATUS_HEIGHT - dy - 1;


	//   ׷ ̹ ġ
	dy = pMe->imgGame[IMG_FINDCHECK].info.cy;
	pMe->find_remaincha_x		= 0;
	pMe->find_remaincha_y		= pMe->canvas_height - STATUS_HEIGHT - dy;


	// status bar ġ ..
	pMe->find_status_x		= 0;
	pMe->find_status_y		= pMe->canvas_height-STATUS_HEIGHT;

	// ȭ  
	if( pMe->canvas_height > 160 )
		pMe->find_status_x += 20;

	pMe->find_window_x		= pMe->find_status_x;
	pMe->find_window_y		= pMe->find_status_y + 4;
	pMe->find_multiply_x	= pMe->find_status_x + 23;
	pMe->find_multiply_y	= pMe->find_status_y + 10;
	pMe->find_remain_x		= pMe->find_status_x + 61;
	pMe->find_remain_y		= pMe->find_status_y + 3;

	// ȭ  
	if( pMe->canvas_height > 160 )
		pMe->find_status_x += 10;

	pMe->find_time_x		= pMe->find_status_x + 63;
	pMe->find_time_y		= pMe->find_status_y + 3;
	pMe->find_clock_x		= pMe->find_status_x + 70;
	pMe->find_clock_y		= pMe->find_status_y + 18;
	pMe->find_point_x		= pMe->find_status_x + 93;
	pMe->find_point_y		= pMe->find_status_y + 18;

	// ȭ  
	if( pMe->canvas_height > 160 )
		pMe->find_status_x += 15;

	pMe->find_calendar_x	= pMe->find_status_x + 96;
	pMe->find_calendar_y	= pMe->find_status_y + 3;
	pMe->find_day_x			= pMe->find_status_x + 113;
	pMe->find_day_y			= pMe->find_status_y + 10;
	pMe->find_lv_x			= pMe->find_status_x + 118;
	pMe->find_lv_y			= pMe->find_status_y + 13;



	// result ġ 
	pMe->find_resultup_x	= 10;
	pMe->find_resultup_y	= 10;
	pMe->find_resultup_dx	= 100;
	pMe->find_resultup_dy	= 40;

	// ȭ  
	if( pMe->canvas_height > 160 ) 
	{
		pMe->find_resultup_x += 30;
		pMe->find_resultup_y += 40;
	}

	pMe->find_resultdn_x	= pMe->find_resultup_x;
	pMe->find_resultdn_y	= pMe->find_resultup_y + pMe->find_resultup_dy;
	pMe->find_resultdn_dx	= 100;
	pMe->find_resultdn_dy	= 35;



	pMe->find_backDraw		= FALSE;
	pMe->find_state			= FSTATE_READY;


	pMe->find_resultbackDraw = FALSE;

	// set guage
//	setGuage(pMe,pMe->find_scorebar_x,pMe->find_scorebar_y,7,IMG_GUAGE,GUAGE_HORZ); // for score
//	setGuage(pMe,pMe->find_timebar_x,pMe->find_timebar_y,30,IMG_GUAGE2,GUAGE_HORZ);	// for time

	findReset(pMe);
}

void findReset(CMoso* pMe)
{
	int i=0;
	int rand;


	// set which character will move.
	MEMSET(pMe->find_move,0,sizeof(boolean)*9);

	while( i < pMe->find_moveMax )
	{
		rand = getRand(pMe,9);
		if(pMe->find_move[rand] != 1)
		{
			pMe->find_move[rand] = 1;
			i++;
		}
	}


	pMe->find_seqFlag		= getRand(pMe,FIND_NUMRANDSEQ);
	pMe->find_spotFlag		= 0;
	pMe->find_accumulFlag	= 0;
	pMe->find_iter			= 0;
	pMe->find_spotStart		= 0;
	pMe->find_spotEnd		= 0;
	pMe->find_right			= 0;

	pMe->find_answer		= FALSE;



	// ÿ    ϱ.
	findGetConcurr(pMe);


	pMe->find_ready		= FALSE;
	pMe->find_input		= FALSE;
	pMe->find_end		= FALSE;


	pMe->find_cutInput	= FALSE;


	pMe->find_moved		= FALSE;

}

// 9  迭 ڰ ġ ʰ 0 ~ 8  ڸ ִ´.
//   ġ ʰ ϱⰡ  ׳ ھ ..
void findGetNonoverlapRand(CMoso* pMe)
{
	pMe->find_seq[0][0] = 3;
	pMe->find_seq[0][1] = 1;
	pMe->find_seq[0][2] = 5;
	pMe->find_seq[0][3] = 8;
	pMe->find_seq[0][4] = 2;
	pMe->find_seq[0][5] = 4;
	pMe->find_seq[0][6] = 6;
	pMe->find_seq[0][7] = 7;
	pMe->find_seq[0][8] = 0;

	pMe->find_seq[1][0] = 7;
	pMe->find_seq[1][1] = 6;
	pMe->find_seq[1][2] = 3;
	pMe->find_seq[1][3] = 2;
	pMe->find_seq[1][4] = 8;
	pMe->find_seq[1][5] = 0;
	pMe->find_seq[1][6] = 1;
	pMe->find_seq[1][7] = 4;
	pMe->find_seq[1][8] = 5;

	pMe->find_seq[2][0] = 5;
	pMe->find_seq[2][1] = 8;
	pMe->find_seq[2][2] = 7;
	pMe->find_seq[2][3] = 2;
	pMe->find_seq[2][4] = 3;
	pMe->find_seq[2][5] = 1;
	pMe->find_seq[2][6] = 6;
	pMe->find_seq[2][7] = 4;
	pMe->find_seq[2][8] = 0;

	pMe->find_seq[3][0] = 0;
	pMe->find_seq[3][1] = 8;
	pMe->find_seq[3][2] = 2;
	pMe->find_seq[3][3] = 7;
	pMe->find_seq[3][4] = 5;
	pMe->find_seq[3][5] = 3;
	pMe->find_seq[3][6] = 4;
	pMe->find_seq[3][7] = 6;
	pMe->find_seq[3][8] = 1;

	pMe->find_seq[4][0] = 2;
	pMe->find_seq[4][1] = 3;
	pMe->find_seq[4][2] = 8;
	pMe->find_seq[4][3] = 5;
	pMe->find_seq[4][4] = 6;
	pMe->find_seq[4][5] = 1;
	pMe->find_seq[4][6] = 0;
	pMe->find_seq[4][7] = 4;
	pMe->find_seq[4][8] = 7;
}



// ÿ    , 迭  ȴ.
// 0 ̶   .
void findGetConcurr(CMoso* pMe)
{
	int rand;

	while( 1 )
	{
		rand = getRand(pMe,pMe->find_spotMax);
		rand = (rand == 0) ? pMe->find_spotMax : rand;

		if( rand + pMe->find_accumulFlag > 9 )
		{
			pMe->find_spot[pMe->find_spotFlag] = 9 - pMe->find_accumulFlag;
			pMe->find_spotFlag++;
			break;
		}
		else
		{
			pMe->find_spot[pMe->find_spotFlag] = rand;

			pMe->find_accumulFlag += rand;
			pMe->find_spotFlag++;

			// 9 ٴٶٸ ..
			if( pMe->find_accumulFlag == 9 )
				break;
		}

	}

}

void gotoFind(CMoso* pMe,byte state)
{
	pMe->find_state	= state;
	pMe->find_backDraw = FALSE;
}


void findDrawBg(CMoso* pMe)
{
	if( pMe->find_backDraw == FALSE ) 
	{
		pMe->find_backDraw = TRUE;
		fillRect(pMe,0,0,pMe->canvas_width,pMe->canvas_height,RGB(0,0,0));

		// draw status bar 
		findDrawStatus(pMe);


		// ȭ  
		if( pMe->canvas_height > 160 )
		{
			int x = pMe->imgGame[IMG_FINDBGLEFT].info.cx;

			drawImage(pMe,IMG_FINDBGLEFT,0,0,GFX_LEFT);
			drawImage(pMe,IMG_FINDBGRIGHT,pMe->canvas_width,0,GFX_RIGHT);
			drawImage(pMe,IMG_FINDBGTOP,x,0,GFX_LEFT);
			drawImage(pMe,IMG_FINDBGBOTTOM,x,pMe->canvas_height-STATUS_HEIGHT,GFX_LEFT|GFX_BOTTOM);
		}

		// draw remain cha
		findDrawRemaincha(pMe);

		pMe->find_backDraw = TRUE;
	}
}

void findDrawStatus(CMoso* pMe)
{
	int i;
	int dx,dy;
	int nx;

	int x,y;

	//  ġ
	x = 0;
	y = pMe->canvas_height - STATUS_HEIGHT;

	dx = pMe->imgGame[IMG_STATUSBG].info.cx;
	dy = pMe->imgGame[IMG_STATUSBG].info.cy;

	nx = pMe->canvas_width / dx;

	for(i=0;i<=nx;++i)
		drawImage(pMe,IMG_STATUSBG,x+i*dx,y,GFX_LEFTTOP);


	// draw icon
	x = pMe->find_window_x; y = pMe->find_window_y;
	drawImage(pMe,IMG_FINDMINICHA1,x,y,GFX_LEFTTOP);


	// draw multiply
	x = pMe->find_multiply_x; y = pMe->find_multiply_y;
	drawImage(pMe,IMG_TRASHMULTIPLY,x,y,GFX_LEFTTOP);


	// draw time
	x = pMe->find_time_x; y = pMe->find_time_y;
	drawImage(pMe,IMG_TIME,x,y,GFX_LEFTTOP);


	// draw time guage
	x = pMe->find_clock_x; y = pMe->find_clock_y-1;
	dx = pMe->find_point_x - pMe->find_clock_x;
	dy = 2;
	fillRect(pMe,x,y,dx,dy,RGB(255,255,255));


	// draw clock
	x = pMe->find_clock_x; y = pMe->find_clock_y;
	drawImage(pMe,IMG_CLOCK,x,y,GFX_CENTER);

	switch(pMe->gameMode)
	{
		case GAMEMODE_STORY:
			x = pMe->find_calendar_x; y = pMe->find_calendar_y;
			drawImage(pMe,IMG_CALENDAR,x,y,GFX_LEFTTOP);
			break;

		case GAMEMODE_ENDLESS:
			x = pMe->find_calendar_x; y = pMe->find_calendar_y;
			drawImage(pMe,IMG_TXTLV,x,y,GFX_LEFTTOP);
			break;
	}


}

void findUpdateBg(CMoso* pMe,int who,byte type)
{
	int x,y;

	x = pMe->find_x[who];
	y = pMe->find_y[who];

	setClip(pMe,x-18,y-18,36,36);

	if( type == FIND_BLACK )
	{
		pMe->find_backDraw = FALSE;
		findDrawBg(pMe);
	}
	else
	{
		findDrawNom(pMe,who,type);
	}
}

void findDrawNom(CMoso* pMe,int who,byte type)
{
	int x,y,dx,dy;

	x = pMe->find_x[who];
	y = pMe->find_y[who];
	dx = pMe->imgGame[IMG_FINDCHA1].info.cx/2;
	dy = pMe->imgGame[IMG_FINDCHA1].info.cy;

	/*
	image = pMe->bed_nomImage[who];
	dx = pMe->imgGame[image].info.cx;
	dy = pMe->imgGame[image].info.cy;
	*/

	// ˼ ׷ ֱ..
	//drawCut(pMe,IMG_BEDCHA1,x-18,y-18,0,type,36,36);
	drawCut(pMe,IMG_FINDCHA1,x-dx/2,y-dy/2,0,type,dx,dy);
	
}


void findDrawRemaincha(CMoso* pMe)
{
	int i,max,dx;

	// ׷  
	dx = pMe->imgGame[IMG_FINDCHECK].info.cx;

	//         ͼ ׷.
	max = pMe->find_moveMax;
	for(i=0;i<max;i++)
	{
		drawImage(pMe,
			IMG_FINDREMAINCHA,
			pMe->find_remaincha_x + dx*i + 1,
			pMe->find_remaincha_y,
			GFX_LEFT);
	}
	
	//  ༮ üũ ع.
	max = pMe->find_right;
	for(i=0;i<max;i++)
	{
		drawImage(pMe,
			IMG_FINDCHECK,
			pMe->find_remaincha_x + dx*i + 1,
			pMe->find_remaincha_y,
			GFX_LEFT);
	}	
}



// ȩ 迭ٰ 0 ~ 8  ڸ ϳ  ־ش.
/*
void setNomImage(CMoso* pMe)
{
	int i,j,k;
	int rand;

	MEMSET(pMe->find_nomImage,0,sizeof(int)*9);


	for(i=0;i<9;i++)
	{
		rand = getRand(pMe,9);

		for(j=0;j<i;j++)
		{
			if( pMe->find_nomImage[j] == rand )
			{
				for(k=0;k<i;k++)
				{
					if( pMe->bed_nomImage[k] != k)
					{
						rand = k;
						break;
					}
				}
			}			
		}
		pMe->bed_nomImage[i] = rand;
	}
}
*/

void findDrawTime(CMoso* pMe)
{
	int x,y,dx,dy;
	int percent;
	int timeguage_width = pMe->find_point_x - pMe->find_clock_x;

	if( pMe->find_wholeTime != 0 ) {
		percent = (pMe->find_currTime << 8) / pMe->find_wholeTime; 
		percent = (percent * timeguage_width) >> 8;
		if( percent > timeguage_width ) 
			percent = timeguage_width;
	}

	// redraw bg
	x = pMe->find_clock_x-5; y = pMe->find_clock_y-5;	
	dx = 33;
	dy = 10;
	setClip(pMe,x,y,dx,dy);
	pMe->find_backDraw = FALSE;
	findDrawBg(pMe);	

	// draw point
	x = pMe->find_point_x - percent; y = pMe->find_clock_y;
	drawImage(pMe,IMG_POINT,x,y,GFX_CENTER);
}

void findDrawScore(CMoso* pMe)
{
	int x,y,dx,dy;

	dx = pMe->imgGame[IMG_NUMBER1].info.cx/10;
	dy = pMe->imgGame[IMG_NUMBER1].info.cy;

	x = pMe->find_remain_x; y = pMe->find_remain_y;	
	setClip(pMe,x-dx*2,y,dx*2,dy);	//  2  µȴٰ .
	pMe->find_backDraw = FALSE;
	findDrawBg(pMe);	
	drawGNumber(pMe,pMe->find_currScore,x,y,GNUM_TYPE1);
}

void findDrawDay(CMoso* pMe)
{
	int x,y,dx,dy;
	int num;

	if( pMe->gameMode == GAMEMODE_STORY )
	{
		x = pMe->find_day_x;
		y = pMe->find_day_y;
		num = pMe->story_day+1;
	}
	else// if( pMe->gameMode == GAMEMODE_ENDLESS )
	{
		x = pMe->find_lv_x;
		y = pMe->find_lv_y;
		num = pMe->endless_findlv+1;
	}
	dx = pMe->imgGame[IMG_NUMBER2].info.cx/10;
	dy = pMe->imgGame[IMG_NUMBER2].info.cy;


	// redraw bg
	setClip(pMe,x-dx*2,y,dx*2,dy);
	pMe->find_backDraw = FALSE;
	findDrawBg(pMe);

	// draw point
	drawGNumber(pMe,num,x,y,GNUM_TYPE2);
}
