#include "moso.h"
#include "menu.h"

#include "save.h"
#include "trash.h"
#include "find.h"
#include "dig.h"
#include "happysnd.h"
#include "socket.h"



// Menu Tick & Draw
void menuTick(CMoso* pMe)
{
	switch( pMe->menu_State )
	{
		// Main
		case MSTATE_MAIN:
			if ((pMe->keyCurr & GKEY_SELECT && pMe->menu_Ani == 0 ) != 0 )
			{
				switch(pMe->menu_Curr)
				{					
					case 0:	// 丮
						gotoMenu(pMe,MSTATE_STORYMODECONFIRM);
						break;
						
					case 1:	// Ѹ		
						gotoMenu(pMe,MSTATE_ENDLESSMODE);
						break;

					case 2:	// ȯ漳
//						loadData(pMe);
						gotoMenu(pMe,MSTATE_SETTING);
						break;

					case 3:	// 
						gotoMenu(pMe,MSTATE_INFO);
						break;

					case 4:	// ŷ
						gotoMenu(pMe,MSTATE_GETRANKINGCONFIRM);
						break;

					case 5:	// ̿
						gotoMenu(pMe,MSTATE_FEE);
						break;

					case 6:	// 
						gotoMenu(pMe,MSTATE_EXIT);
						break;
				}
			}
			
			// Move left and right on main page.
			else if ((pMe->keyCurr & (GKEY_RIGHT | GKEY_6)) != 0)
			{
				// ޴ ׸ ̵ϴ°
				pMe->menu_Direction = -1;	// set menu direction
				pMe->menu_Ani = 2;			// set menu animation 
				pMe->menu_Prev = pMe->menu_Curr;
				pMe->menu_Curr++;

				if (pMe->menu_Curr == pMe->menu_Numitem)
					pMe->menu_Curr = 0;

#if CHEAT_HIDERANKING
				// ŷ ǳʶٱ
				if( pMe->menu_Curr == 4 )
					pMe->menu_Curr = 5;
#endif
				sfx_play(pMe,SND_MENUMOVE,FALSE);

			}
			else if ((pMe->keyCurr & (GKEY_LEFT | GKEY_4)) != 0) 			
			{
				pMe->menu_Direction = +1;	// set menu direction
				pMe->menu_Ani = 2;			// set menu animation 
				pMe->menu_Prev = pMe->menu_Curr;
				pMe->menu_Curr--;

				if (pMe->menu_Curr < 0)
					pMe->menu_Curr = pMe->menu_Numitem-1;			

#if CHEAT_HIDERANKING
				// ŷ ǳʶٱ
				if( pMe->menu_Curr == 4 )
					pMe->menu_Curr = 3;
#endif

				sfx_play(pMe,SND_MENUMOVE,FALSE);
			}
			break;

		// ϱ/̾ϱ
		case MSTATE_STORYMODECONFIRM:
			// Move up and down on info page
			if ((pMe->keyCurr & (GKEY_DOWN | GKEY_8)) != 0)
			{
				// ޴ ׸ ̵ϴ°
				pMe->menu_Start++;

				if (pMe->menu_Start == 2)
					pMe->menu_Start = 0;
			}
			else if ((pMe->keyCurr & (GKEY_UP | GKEY_2)) != 0) 			
			{
				// ޴ ׸ ̵ϴ°
				pMe->menu_Start--;

				if (pMe->menu_Start == -1)
					pMe->menu_Start = 1;
			}
			else if ((pMe->keyCurr & (GKEY_SELECT) ) != 0)
			{
				// 丮  
				pMe->gameMode	= GAMEMODE_STORY;

				//    Ű.
				sfx_stop(pMe);

				if( pMe->menu_Start == 0 ) // if focus is on '̾ϱ'
				{
					// ڷ о鿩.
//					loadData(pMe);

					if( pMe->story_stage == GAME_STORY_STAGE )
					{
						//  .
						// STATE_ANISTORY ϶ anistory_type    Ѵ.
						pMe->anistory_type = 1;	// happyend
						SETSTATE(pMe,STATE_ANISTORY);	
						return;
					}
					else
					{
						// ù° ̶,   Ͱ ų  Ϸ絵  ʾҴٸ..
						if( pMe->story_day == 0 )
						{
							// STATE_ANISTORY ϶ anistory_type    Ѵ.
							pMe->anistory_type = 0;	// prologue
							SETSTATE(pMe,STATE_ANISTORY);	
						}
						//  ڷᰡ ִٸ Ϸ縦 Ѵ.
						else
						{
							SETSTATE(pMe,STATE_STARTDAY);
						}
					}
				}
				else if( pMe->menu_Start == 1 ) // if focus is on 'ϱ'
				{	
					//  ʱȭ Ű.
					pMe->story_day			= 0;
					pMe->story_stage		= 0;
					pMe->story_trashstage	= 0;
					pMe->story_findstage	= 0;					
					pMe->story_power		= 1;
					pMe->story_weapon		= 1;
					pMe->story_itemNum		= 0; //  0  .
					MEMSET(pMe->story_item,0,sizeof(byte)*GAME_STORY_DAY);				
					

					saveData(pMe);
					
					// STATE_ANISTORY ϶ anistory_type    Ѵ.
					pMe->anistory_type = 0;	// prologue
					SETSTATE(pMe,STATE_ANISTORY);	
				}

			}
			else if((pMe->keyCurr & GKEY_BACK) != 0)
			{
				gotoMenu(pMe,MSTATE_MAIN);
			}
			break;

		// Ѹ
		case MSTATE_ENDLESSMODE:
			// Move up and down on info page
			if ((pMe->keyCurr & (GKEY_DOWN | GKEY_8)) != 0)
			{
				// ޴ ׸ ̵ϴ°
				pMe->menu_Special++;

				if (pMe->menu_Special == 3)
					pMe->menu_Special = 0;
			}
			else if ((pMe->keyCurr & (GKEY_UP | GKEY_2)) != 0) 			
			{
				// ޴ ׸ ̵ϴ°
				pMe->menu_Special--;

				if (pMe->menu_Special == -1)
					pMe->menu_Special = 2;
			}
			else if ((pMe->keyCurr & (GKEY_SELECT) ) != 0)
			{
				//   - ϱ/̾ϱ
				gotoMenu(pMe,MSTATE_ENDLESSMODECONFIRM);
			}
			else if((pMe->keyCurr & GKEY_BACK) != 0)
			{
				gotoMenu(pMe,MSTATE_MAIN);
			}
			break;

		case MSTATE_ENDLESSMODECONFIRM:
			// Move up and down on info page
			if ((pMe->keyCurr & (GKEY_DOWN | GKEY_8)) != 0)
			{
				// ޴ ׸ ̵ϴ°
				pMe->menu_SpecialConfirm++;

				if (pMe->menu_SpecialConfirm == 2)
					pMe->menu_SpecialConfirm = 0;
			}
			else if ((pMe->keyCurr & (GKEY_UP | GKEY_2)) != 0) 			
			{
				// ޴ ׸ ̵ϴ°
				pMe->menu_SpecialConfirm--;

				if (pMe->menu_SpecialConfirm == -1)
					pMe->menu_SpecialConfirm = 1;
			}
			else if ((pMe->keyCurr & (GKEY_SELECT) ) != 0)
			{
				//  
				pMe->gameMode	= GAMEMODE_ENDLESS; 


				if( pMe->menu_SpecialConfirm == 0 ) // if focus is on '̾ϱ'
				{
					// ڷ о鿩.
//					loadData(pMe);

					//    Ű.
					sfx_stop(pMe);

					if( pMe->menu_Special == 0 ) // if focus is on 'â'
					{							
						trashInit(pMe);
						SETSTATE(pMe,STATE_TRASH);
					}
					else if( pMe->menu_Special == 1 ) // if focus is on '˿'
					{
						findInit(pMe);
						SETSTATE(pMe,STATE_FIND);
					}
					else if( pMe->menu_Special == 2 ) // if focus is on 'ı'
					{
						digInit(pMe);
						SETSTATE(pMe,STATE_DIG);
					}

				}
				else if( pMe->menu_SpecialConfirm == 1 ) // if focus is on 'ϱ'
				{	
					//    Ű.
					sfx_stop(pMe);

					if( pMe->menu_Special == 0 ) // if focus is on 'â'
					{
						pMe->endless_trashlv = 0;
						saveData(pMe);

						trashInit(pMe);
						SETSTATE(pMe,STATE_TRASH);
					}
					else if( pMe->menu_Special == 1 ) // if focus is on '˿'
					{
						pMe->endless_findlv = 0;
						saveData(pMe);

						findInit(pMe);
						SETSTATE(pMe,STATE_FIND);
					}
					else if( pMe->menu_Special == 2 ) // if focus is on 'ı'
					{
						pMe->endless_diglv = 0;
						saveData(pMe);

						digInit(pMe);
						SETSTATE(pMe,STATE_DIG);
					}
				}
			}
			else if((pMe->keyCurr & GKEY_BACK) != 0)
			{
				gotoMenu(pMe,MSTATE_ENDLESSMODE);
			}
			break;

		// ȯ漳
		case MSTATE_SETTING:
			// Move up and down on info page
			if ((pMe->keyCurr & (GKEY_DOWN | GKEY_8)) != 0)
			{
				// ޴ ׸ ̵ϴ°
				pMe->menu_SettingCurr++;

				if (pMe->menu_SettingCurr == 2)
					pMe->menu_SettingCurr = 0;
			}
			else if ((pMe->keyCurr & (GKEY_UP | GKEY_2)) != 0) 			
			{
				// ޴ ׸ ̵ϴ°
				pMe->menu_SettingCurr--;

				if (pMe->menu_SettingCurr == -1)
					pMe->menu_SettingCurr = 1;
			}
			else if ((pMe->keyCurr & (GKEY_SELECT) ) != 0)
			{
				if( pMe->menu_SettingCurr == 0 ) // if focus is on ''
				{
					if( pMe->config_isSound == 0 )
					{
						pMe->config_isSound = 1;

						// Ҹ  Ȯ
						sfx_play(pMe,SND_MENUSELECT,FALSE);
					}
					else if( pMe->config_isSound == 1 )
					{
						pMe->config_isSound = 0;

						// Ҹ ش.
						sfx_stop(pMe);
					}
				}
				else if( pMe->menu_SettingCurr == 1 ) // if focus is on ''
				{
					if( pMe->config_isVibration == 0 ) {
						pMe->config_isVibration = 1;

						sfx_vib(pMe,200);
					}
					else if( pMe->config_isVibration == 1 ) {
						pMe->config_isVibration = 0;
					}
				}
			}
			else if((pMe->keyCurr & GKEY_BACK) != 0)
			{
				// save data here.
				saveData(pMe);
				//   ƴ  MSTATE_MAIN, ϶ MSTATE_GAMEMENU
				if( pMe->menu_Gamemenu ) 
					gotoMenu(pMe,MSTATE_GAMEMENU);
				else
					gotoMenu(pMe,MSTATE_MAIN);
			}
			break;

		// ӹ
		case MSTATE_INFO:
			// Move up and down on info page
			if ((pMe->keyCurr & (GKEY_DOWN | GKEY_8)) != 0)
			{
				// ޴ ׸ ̵ϴ°
				pMe->menu_InfoCurr++;

				if (pMe->menu_InfoCurr == 4)
					pMe->menu_InfoCurr = 0;
			}
			else if ((pMe->keyCurr & (GKEY_UP | GKEY_2)) != 0) 			
			{
				// ޴ ׸ ̵ϴ°
				pMe->menu_InfoCurr--;

				if (pMe->menu_InfoCurr == -1)
					pMe->menu_InfoCurr = 3;
			}
			else if ((pMe->keyCurr & (GKEY_SELECT) ) != 0)
			{
				if( pMe->menu_InfoCurr == 0 )	// 丮
					gotoMenu(pMe,MSTATE_STORY);
				else if( pMe->menu_InfoCurr == 1 )	// Ӽ
					gotoMenu(pMe,MSTATE_TUTORIAL);
				else if( pMe->menu_InfoCurr == 2 )	// ۹
				{
					gotoMenu(pMe,MSTATE_KEYHOWTO);
					loadImage(pMe,&pMe->menu_imgKeyInfo,MOSO_RES_FILE,IDB_KEYINFO);
				}
				else if( pMe->menu_InfoCurr == 3 )	// ӹ
					gotoMenu(pMe,MSTATE_ABOUT);
			}
			else if((pMe->keyCurr & GKEY_BACK) != 0)
			{
				//   ƴ  MSTATE_MAIN, ϶ MSTATE_GAMEMENU
				if( pMe->menu_Gamemenu ) 
					gotoMenu(pMe,MSTATE_GAMEMENU);
				else
					gotoMenu(pMe,MSTATE_MAIN);
			}
			break;

		// ӹ -> 丮
		case MSTATE_STORY:
			if((pMe->keyCurr & GKEY_SELECT) != 0)
			{
				stopText(pMe);
				gotoMenu(pMe,MSTATE_INFO);
			}
			else if((pMe->keyCurr & GKEY_BACK) != 0)
			{
				stopText(pMe);
				gotoMenu(pMe,MSTATE_INFO);
			}
			break;

		//  
		case MSTATE_TUTORIAL:
			// Move up and down on info page
			if ((pMe->keyCurr & (GKEY_DOWN | GKEY_8)) != 0)
			{
				// ޴ ׸ ̵ϴ°
				pMe->menu_Tutorial++;

				if (pMe->menu_Tutorial == 3)
					pMe->menu_Tutorial = 0;
			}
			else if ((pMe->keyCurr & (GKEY_UP | GKEY_2)) != 0) 			
			{
				// ޴ ׸ ̵ϴ°
				pMe->menu_Tutorial--;

				if (pMe->menu_Tutorial == -1)
					pMe->menu_Tutorial = 2;
			}
			else if ((pMe->keyCurr & (GKEY_SELECT) ) != 0)
			{
				if( pMe->menu_Tutorial == 0 )
					gotoMenu(pMe,MSTATE_TRASH);
				else if( pMe->menu_Tutorial == 1 )
					gotoMenu(pMe,MSTATE_FIND);
				else if( pMe->menu_Tutorial == 2 )
					gotoMenu(pMe,MSTATE_DIG);
			}
			else if((pMe->keyCurr & GKEY_BACK) != 0)
			{
				gotoMenu(pMe,MSTATE_INFO);
			}
			break;

		// ӹ -> ۹
		case MSTATE_KEYHOWTO:
			if((pMe->keyCurr & GKEY_SELECT) != 0)
			{
				gotoMenu(pMe,MSTATE_INFO);
			}
			else if((pMe->keyCurr & GKEY_BACK) != 0)
			{
				freeImage(pMe,&pMe->menu_imgKeyInfo);
				gotoMenu(pMe,MSTATE_INFO);
			}
			break;

		// ӹ -> ۻ
		case MSTATE_ABOUT:
			if((pMe->keyCurr & GKEY_SELECT) != 0)
			{
				stopAnitext(pMe);
				gotoMenu(pMe,MSTATE_INFO);
			}
			else if((pMe->keyCurr & GKEY_BACK) != 0)
			{
				stopAnitext(pMe);
				gotoMenu(pMe,MSTATE_INFO);
			}
			break;

		case MSTATE_TRASH:
		case MSTATE_FIND:
		case MSTATE_DIG:
			if((pMe->keyCurr & GKEY_SELECT) != 0)
			{
				stopText(pMe);
				gotoMenu(pMe,MSTATE_TUTORIAL);
			}
			else if((pMe->keyCurr & GKEY_BACK) != 0)
			{
				stopText(pMe);
				gotoMenu(pMe,MSTATE_TUTORIAL);
			}
			break;

		// ŷ  Ȯ â
		case MSTATE_PUTRANKINGCONFIRM:
			// Move up and down on info page
			if ((pMe->keyCurr & (GKEY_DOWN | GKEY_8)) != 0)
			{
				// ޴ ׸ ̵ϴ°
				pMe->menu_RankingCurr++;

				if (pMe->menu_RankingCurr == 2)
					pMe->menu_RankingCurr = 0;
			}
			else if ((pMe->keyCurr & (GKEY_UP | GKEY_2)) != 0) 			
			{
				// ޴ ׸ ̵ϴ°
				pMe->menu_RankingCurr--;

				if (pMe->menu_RankingCurr == -1)
					pMe->menu_RankingCurr = 1;
			}
			else if((pMe->keyCurr & GKEY_SELECT) != 0)
			{
				// ŷ  ϱ.
				if( pMe->menu_RankingCurr == 0 )
				{
					// ŷ  ؼ Ʈ  ϸ 尡   ִ.
					sfx_stop(pMe);

					gotoMenu(pMe,MSTATE_RANKINGTRANSFER);

					pMe->ranking_type = 0;
					putRank(pMe);					
				}

				// ƴϿ
				else
					gotoMenu(pMe,MSTATE_ENDLESSMODE);
			}
			else if((pMe->keyCurr & GKEY_BACK) != 0)
			{
				gotoMenu(pMe,MSTATE_ENDLESSMODE);
			}
			break;


		// ŷ  Ȯ â
		case MSTATE_RANKINGERROR:
		case MSTATE_RANKINGEMERGENCY:
		case MSTATE_RANKINGRESULT:
			if((pMe->keyCurr & GKEY_SELECT) != 0)
			{
				if( pMe->ranking_type == 0 ) // ŷ  ̾ٸ Ѹ ޴ 
					gotoMenu(pMe,MSTATE_ENDLESSMODE);
				else if( pMe->ranking_type == 1 ) // ŷ  Ȯ ̾ٸ ޴ ŷ .
					gotoMenu(pMe,MSTATE_RANKINGSELECT);
			}
			else if((pMe->keyCurr & GKEY_BACK) != 0)
			{
				if( pMe->ranking_type == 0 ) // ŷ  ̾ٸ Ѹ ޴ 
					gotoMenu(pMe,MSTATE_ENDLESSMODE);
				else if( pMe->ranking_type == 1 ) // ŷ  Ȯ ̾ٸ ޴ ŷ .
					gotoMenu(pMe,MSTATE_RANKINGSELECT);
			}
			stopText(pMe);
			break;

		// ŷ  Ȯ
		case MSTATE_GETRANKINGCONFIRM:
			// Move up and down on info page
			if ((pMe->keyCurr & (GKEY_DOWN | GKEY_8)) != 0)
			{
				// ޴ ׸ ̵ϴ°
				pMe->menu_RankingCurr++;

				if (pMe->menu_RankingCurr == 2)
					pMe->menu_RankingCurr = 0;
			}
			else if ((pMe->keyCurr & (GKEY_UP | GKEY_2)) != 0) 			
			{
				// ޴ ׸ ̵ϴ°
				pMe->menu_RankingCurr--;

				if (pMe->menu_RankingCurr == -1)
					pMe->menu_RankingCurr = 1;
			}
			else if((pMe->keyCurr & GKEY_SELECT) != 0)
			{
				// 
				if( pMe->menu_RankingCurr == 0 )
					gotoMenu(pMe,MSTATE_RANKINGSELECT);

				// ƴϿ
				else
					gotoMenu(pMe,MSTATE_MAIN);
			}
			else if((pMe->keyCurr & GKEY_BACK) != 0)
			{
				gotoMenu(pMe,MSTATE_MAIN);
			}
			break;

		// ŷ ϱ
		case MSTATE_RANKINGSELECT:
			// Move up and down on info page
			if ((pMe->keyCurr & (GKEY_DOWN | GKEY_8)) != 0)
			{
				// ޴ ׸ ̵ϴ°
				pMe->menu_RankingSelectCurr++;

				if (pMe->menu_RankingSelectCurr == 3)
					pMe->menu_RankingSelectCurr = 0;
			}
			else if ((pMe->keyCurr & (GKEY_UP | GKEY_2)) != 0) 			
			{
				// ޴ ׸ ̵ϴ°
				pMe->menu_RankingSelectCurr--;

				if (pMe->menu_RankingSelectCurr == -1)
					pMe->menu_RankingSelectCurr = 2;
			}
			else if((pMe->keyCurr & GKEY_SELECT) != 0)
			{	
				gotoMenu(pMe,MSTATE_RANKINGTRANSFER);

				pMe->ranking_type = 1;
				getRank(pMe);				
			}
			else if((pMe->keyCurr & GKEY_BACK) != 0)
			{
				gotoMenu(pMe,MSTATE_GETRANKINGCONFIRM);
			}
			break;

		// ̿
		case MSTATE_FEE:
			if((pMe->keyCurr & GKEY_SELECT) != 0)
			{
				stopText(pMe);
				gotoMenu(pMe,MSTATE_MAIN);
			}
			else if((pMe->keyCurr & GKEY_BACK) != 0)
			{
				stopText(pMe);
				gotoMenu(pMe,MSTATE_MAIN);				
			}
			break;

		//  
		case MSTATE_EXIT:
     		//if ((GET_UPTIMEMS() - pMe->startTime) > LOGOTIME)
			//{
				//  ϰ
				//SD_Save(pMe);


				ISHELL_CancelTimer(pMe->a.m_pIShell,NULL,pMe);
				ISHELL_CloseApplet(pMe->a.m_pIShell,FALSE);	
			//}
			break;

		//  ޴..
		case MSTATE_GAMEMENU:
			// Move up and down on info page
			if ((pMe->keyCurr & (GKEY_DOWN | GKEY_8)) != 0)
			{
				// ޴ ׸ ̵ϴ°
				pMe->menu_gamemenuCurr++;

				if (pMe->menu_gamemenuCurr == 4)
					pMe->menu_gamemenuCurr = 0;
			}
			else if ((pMe->keyCurr & (GKEY_UP | GKEY_2)) != 0) 			
			{
				// ޴ ׸ ̵ϴ°
				pMe->menu_gamemenuCurr--;

				if (pMe->menu_gamemenuCurr == -1)
					pMe->menu_gamemenuCurr = 3;
			}
			else if ( (pMe->keyCurr & GKEY_SELECT) != 0 || (pMe->keyCurr & GKEY_BACK) != 0 )
			{
				// Back  ϱ⸦  Ͱ .
				if( (pMe->keyCurr & GKEY_BACK) != 0 )
					pMe->menu_gamemenuCurr = 0;

				switch(pMe->menu_gamemenuCurr)
				{
					case 0:	// ϱ
						// Ҹ ߰.
						sfx_stop(pMe);

						if( pMe->gPrevState == STATE_TRASH )
						{
							//  ޴ ȣ  ִٸ  ð ٽ ش.
							if( pMe->trash_startTime != 0 )
							{
								pMe->trash_startTime = GET_UPTIMEMS();
								pMe->trash_startTime -= pMe->trash_currTime;
							}

							// READY   ޴   ٽ READY  ưش.
							if(pMe->trash_state == TSTATE_READY)
							{
								trashInit(pMe);
								SETSTATE(pMe,STATE_TRASH);
							}
							else
							{
								gotoTrash(pMe,pMe->trash_state);
								SETSTATE(pMe,STATE_TRASH);
							}
						}
						else if( pMe->gPrevState == STATE_FIND )
						{
							//  ޴ ȣ  ִٸ  ð ٽ ش.
							if( pMe->find_startTime != 0 )
							{
								pMe->find_startTime = GET_UPTIMEMS();
								pMe->find_startTime -= pMe->find_currTime;
							}

							// ˿ END  ƴҶ  READY  .
							if( pMe->find_state != FSTATE_END ) {
								findReset(pMe);						
								gotoFind(pMe,FSTATE_READY);
	  
								SETSTATE(pMe,STATE_FIND);
							}
							else {
								gotoFind(pMe,FSTATE_END);
								SETSTATE(pMe,STATE_FIND);
							}
						}
						else if( pMe->gPrevState == STATE_DIG )
						{
							//  ޴ ȣ  ִٸ  ð ٽ ش.
							if( pMe->dig_startTime != 0 )
							{
								pMe->dig_startTime = GET_UPTIMEMS();
								pMe->dig_startTime -= pMe->dig_currTime;
							}

							// READY   ޴   ٽ READY  ưش.
							if(pMe->dig_state == DSTATE_READY)
							{
								digInit(pMe);
								SETSTATE(pMe,STATE_DIG);
							}
							else
							{
								gotoDig(pMe,pMe->dig_state);
								SETSTATE(pMe,STATE_DIG);
							}
						}
						break;
						
					case 1:	// ȯ漳			
						gotoMenu(pMe,MSTATE_SETTING);
						break;

					case 2:	// 
						gotoMenu(pMe,MSTATE_INFO);
						break;

					case 3:	// θ޴
						if( pMe->gameMode == GAMEMODE_STORY )
							gotoMenu(pMe,MSTATE_MAIN);
						else if( pMe->gameMode == GAMEMODE_ENDLESS )
							gotoMenu(pMe,MSTATE_ENDLESSMODE);
						break;
				}
			}
			break;
	}
	pMe->keyCurr = GKEY_NONE;
}

void menuDraw(CMoso* pMe)
{
	int x,x2,y,dx,dy;
	int gap;
	switch(pMe->menu_State)
	{
		// Main
		case MSTATE_MAIN:
			setScreen(pMe);
			menuDrawBg(pMe);
			menuDrawItem(pMe);
			break;


		// ϱ/̾ϱ
		case MSTATE_STORYMODECONFIRM:
			// draw menupan
			setClip(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy);
			menuDrawPan(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy,TRUE);

			gap = (pMe->canvas_height < 130) ? 15 : 20;
			x	= pMe->menu_panx + pMe->menu_pandx/2;


			setColor(pMe,255,255,255);
			y	= (pMe->menu_pany + pMe->menu_pandy)/2 - gap;
			drawString(pMe,"̾ϱ",x,y,GFX_CENTER);

			y	= (pMe->menu_pany + pMe->menu_pandy)/2 + gap;
			drawString(pMe,"ϱ",x,y,GFX_CENTER);

			// erase area where menuhand already had been drawn.
			x = x-40;
			if( pMe->menu_Start == 0 )
				y	= (pMe->menu_pany + pMe->menu_pandy)/2 - gap;
			else 
				y	= (pMe->menu_pany + pMe->menu_pandy)/2 + gap;				

			drawForkAni(pMe,y);
			break;

		// 伣 
		case MSTATE_ENDLESSMODE:
			// draw menupan
			setClip(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy);
			menuDrawPan(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy,TRUE);


			gap = (pMe->canvas_height < 130) ? 20 : 25;
			x	= pMe->menu_panx + pMe->menu_pandx/2;

			setColor(pMe,255,255,255);

			y	= (pMe->menu_pany + pMe->menu_pandy)/2 - gap;
			drawString(pMe,"â",x,y,GFX_CENTER);

			y	= (pMe->menu_pany + pMe->menu_pandy)/2;
			drawString(pMe,"˿",x,y,GFX_CENTER);

			y	= (pMe->menu_pany + pMe->menu_pandy)/2 + gap;
			drawString(pMe,"ı",x,y,GFX_CENTER);



			// erase area where menuhand already had been drawn.
			x = x-40;
			if( pMe->menu_Special == 0 )
				y	= (pMe->menu_pany + pMe->menu_pandy)/2 - gap;
			else if( pMe->menu_Special == 1 )
				y	= (pMe->menu_pany + pMe->menu_pandy)/2;
			else if( pMe->menu_Special == 2 )
				y	= (pMe->menu_pany + pMe->menu_pandy)/2 + gap;				

			drawForkAni(pMe,y);	
			break;


		case MSTATE_ENDLESSMODECONFIRM:
			// draw menupan
			setClip(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy);
			menuDrawPan(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy,TRUE);

			gap = (pMe->canvas_height < 130) ? 15 : 20;
			x	= pMe->menu_panx + pMe->menu_pandx/2;

			setColor(pMe,255,255,255);

			y	= (pMe->menu_pany + pMe->menu_pandy)/2 - gap;
			drawString(pMe,"̾ϱ",x,y,GFX_CENTER);

			y	= (pMe->menu_pany + pMe->menu_pandy)/2 + gap;
			drawString(pMe,"ϱ",x,y,GFX_CENTER);


			// erase area where menuhand already had been drawn.
			x = x-40;
			if( pMe->menu_SpecialConfirm == 0 )
				y	= (pMe->menu_pany + pMe->menu_pandy)/2 - gap;
			else if( pMe->menu_SpecialConfirm == 1 )
				y	= (pMe->menu_pany + pMe->menu_pandy)/2 + gap;				

			drawForkAni(pMe,y);	
			break;

		// ȯ漳
		case MSTATE_SETTING:
			// draw menupan
			setClip(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy);
			menuDrawPan(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy,TRUE);

			gap = (pMe->canvas_height < 130) ? 15 : 20;
			x	= pMe->menu_panx + pMe->menu_pandx/3;
			x2	= pMe->menu_panx + pMe->menu_pandx - pMe->menu_pandx/3;

			//////////////////////////////////////////////////////////////////////
			// draw sound
			setScreen(pMe);						
			setColor(pMe,255,255,255);

			y	= (pMe->menu_pany + pMe->menu_pandy)/2 - gap;
			drawString(pMe,"",x,y,GFX_CENTER);

			// erase area where already on/off image already had been drawn.
			dx= pMe->imgGame[IMG_MENUOFF].info.cx;
			dy= pMe->imgGame[IMG_MENUOFF].info.cy;
			setClip(pMe,x2-dx/2,y-dy/2,dx,dy);
			pMe->menu_panDraw = FALSE;
			menuDrawPan(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy,FALSE);

			// draw on/off image
			if( pMe->config_isSound == 0 )			drawImage(pMe,IMG_MENUOFF,x2,y,GFX_CENTER);
			else if( pMe->config_isSound == 1 )	drawImage(pMe,IMG_MENUON,x2,y,GFX_CENTER);
			//===============================================================


			//////////////////////////////////////////////////////////////////////
			// draw vibration
			setScreen(pMe);
			setColor(pMe,255,255,255);


			// draw .
			y	= (pMe->menu_pany + pMe->menu_pandy)/2 + gap;
			drawString(pMe,"",x,y,GFX_CENTER);	

			// erase area where already on/off image already had been drawn.
			dx= pMe->imgGame[IMG_MENUOFF].info.cx;
			dy= pMe->imgGame[IMG_MENUOFF].info.cy;
			setClip(pMe,x2-dx/2,y-dy/2,dx,dy);
			pMe->menu_panDraw = FALSE;
			menuDrawPan(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy,FALSE);

			// draw on/off image
			if( pMe->config_isVibration == 0 )			drawImage(pMe,IMG_MENUOFF,x2,y,GFX_CENTER);
			else if( pMe->config_isVibration == 1 )	drawImage(pMe,IMG_MENUON,x2,y,GFX_CENTER);
			//===============================================================


			// erase area where menuhand already had been drawn.
			x = x-30;
			if( pMe->menu_SettingCurr == 0 )
				y	= (pMe->menu_pany + pMe->menu_pandy)/2 - gap;
			else if( pMe->menu_SettingCurr == 1 )
				y	= (pMe->menu_pany + pMe->menu_pandy)/2 + gap;

			drawForkAni(pMe,y);	
			break;

		// 
		case MSTATE_INFO:
			// draw menupan
			setClip(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy);
			menuDrawPan(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy,TRUE);

			x	= pMe->menu_panx + pMe->menu_pandx/2;

			// ȭ  
			if( pMe->canvas_height < 160 )
				y = 0;
			else
				y = 30;

			setColor(pMe,255,255,255);
			y += pMe->imgGame[IMG_TXTINFO].info.cy + pMe->font_h/2;
			drawString(pMe,"丮",x,y,GFX_CENTER);
			y += (pMe->canvas_height < 130) ? pMe->font_h : (int)(pMe->font_h*1.5);
			drawString(pMe,"Ӽ",x,y,GFX_CENTER);
			y += (pMe->canvas_height < 130) ? pMe->font_h : (int)(pMe->font_h*1.5);
			drawString(pMe,"۹",x,y,GFX_CENTER);
			y += (pMe->canvas_height < 130) ? pMe->font_h : (int)(pMe->font_h*1.5);
			drawString(pMe,"ӹ",x,y,GFX_CENTER);
			
			// erase area where menuhand already had been drawn.
			x = x-40;
			// ȭ  
			if( pMe->canvas_height < 160 )
				y = 0;
			else
				y = 30;
			y += pMe->imgGame[IMG_TXTINFO].info.cy + pMe->font_h/2 +				
				 pMe->menu_InfoCurr * ((pMe->canvas_height < 130) ? pMe->font_h : (int)(pMe->font_h*1.5));

			drawForkAni(pMe,y);	
			break;

		// 丮
		case MSTATE_STORY:
			// draw menupan
			setClip(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy);
			menuDrawPan(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy,TRUE);

			setColor(pMe,255,255,255);

			x	= 0;
			y	= pMe->imgGame[IMG_TXTSTORY].info.cy;
			dx	= pMe->canvas_width;
			dy	= pMe->canvas_height - pMe->imgGame[IMG_TXTSTORY].info.cy - pMe->imgGame[IMG_MINIPAN].info.cy;

			// ȭ  
			if( pMe->canvas_height > 160 ) {
				y += 20;
				dy -= 20*2;
			}

			initText(pMe,pMe->main_story,dx,dy,GFX_LEFT);
			drawText(pMe,x,y,dx,dy,FALSE);
			break;

		//  
		case MSTATE_TUTORIAL:
			// draw menupan
			setClip(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy);
			menuDrawPan(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy,TRUE);

			gap = (pMe->canvas_height < 130) ? 20 : 25;
			x	= pMe->menu_panx + pMe->menu_pandx/2;

			setColor(pMe,255,255,255);
			y	= (pMe->menu_pany + pMe->menu_pandy)/2 - gap;
			drawString(pMe,"â",x,y,GFX_CENTER);

			y	= (pMe->menu_pany + pMe->menu_pandy)/2;
			drawString(pMe,"˿",x,y,GFX_CENTER);

			y	= (pMe->menu_pany + pMe->menu_pandy)/2 + gap;
			drawString(pMe,"ı",x,y,GFX_CENTER);


			// erase area where menuhand already had been drawn.
			x = x-40;
			if( pMe->menu_Tutorial == 0 )
				y	= (pMe->menu_pany + pMe->menu_pandy)/2 - gap;
			else if( pMe->menu_Tutorial == 1 )
				y	= (pMe->menu_pany + pMe->menu_pandy)/2;
			else if( pMe->menu_Tutorial == 2 )
				y	= (pMe->menu_pany + pMe->menu_pandy)/2 + gap;	

			drawForkAni(pMe,y);	
			break;

		case MSTATE_TRASH:
		case MSTATE_FIND:
		case MSTATE_DIG:
			{
				char* tuto = NULL;
				int x,y,dx,dy;	
				
		
				// draw menupan
				setClip(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy);
				menuDrawPan(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy,TRUE);

				setColor(pMe,255,255,255);


				if( pMe->menu_Tutorial == 0 )		tuto = pMe->tutorial_trashstory;
				else if( pMe->menu_Tutorial == 1 )	tuto = pMe->tutorial_findstory;
				else if( pMe->menu_Tutorial == 2 )		tuto = pMe->tutorial_digstory;

				x	= 0;
				y	= pMe->imgGame[IMG_TXTTUTORIAL].info.cy;
				dx	= pMe->canvas_width;
				dy	= pMe->canvas_height - pMe->imgGame[IMG_TXTTUTORIAL].info.cy - pMe->imgGame[IMG_MINIPAN].info.cy;

				// ȭ  
				if( pMe->canvas_height > 160 ) {
					y += 20;
					dy -= 20*2;
				}


				initText(pMe,tuto,dx,dy,GFX_LEFT);
				drawText(pMe,x,y,dx,dy,FALSE);
			
			}
			break;

		// Ű
		case MSTATE_KEYHOWTO:
			// draw menupan
			setClip(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy);
			menuDrawPan(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy,FALSE);

			// draw instruction
			drawImage2(pMe,&pMe->menu_imgKeyInfo,pMe->canvas_midx,pMe->canvas_midy,GFX_CENTER);
			break;


		// ӹ
		case MSTATE_ABOUT:
			// draw menupan
			setClip(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy);
			menuDrawPan(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy,TRUE);

			x = pMe->canvas_midx;
			y = pMe->imgGame[IMG_TXTABOUT].info.cy;

			dx = pMe->imgGame[IMG_STAFFDAUM].info.cx;
			dy = pMe->imgGame[IMG_STAFFDAUM].info.cy;


			// ȭ  
			if( pMe->canvas_height > 160 ) {
				y += 20;
			}

			// change staff face
			if( pMe->anitext_frame < 18 ) {
				setClip(pMe,x-dx/2,y,dx,dy);
				pMe->menu_panDraw = FALSE;
				menuDrawPan(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy,TRUE);
				drawImage(pMe,IMG_STAFFDAUM,x,y,GFX_HCENTER|GFX_TOP);
			}
			else if( pMe->anitext_frame < 22 ) {
				setClip(pMe,x-dx/2,y,dx,dy);
				pMe->menu_panDraw = FALSE;
				menuDrawPan(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy,TRUE);
				drawImage(pMe,IMG_STAFFSPARKDH,x,y,GFX_HCENTER|GFX_TOP);
			}
			else if( pMe->anitext_frame < 26 ) {
				drawImage(pMe,IMG_STAFFFRONTA,x,y,GFX_HCENTER|GFX_TOP);
			}
			else if( pMe->anitext_frame < 30 ) {
				drawImage(pMe,IMG_STAFFNCH,x,y,GFX_HCENTER|GFX_TOP);
			}
			else if( pMe->anitext_frame < 34 ) {
				drawImage(pMe,IMG_STAFFKYH,x,y,GFX_HCENTER|GFX_TOP);
			}
			else {
				drawImage(pMe,IMG_STAFFKBCKBC,x,y,GFX_HCENTER|GFX_TOP);
			}

			x	= 0;
			y	= pMe->imgGame[IMG_TXTABOUT].info.cy + pMe->imgGame[IMG_STAFFSPARKDH].info.cy;
			dx	= pMe->canvas_width;
			dy	= pMe->canvas_height 
					- pMe->imgGame[IMG_STAFFSPARKDH].info.cy 
					- pMe->imgGame[IMG_TXTABOUT].info.cy 
					- pMe->imgGame[IMG_MINIPAN].info.cy;

			// ȭ  
			if( pMe->canvas_height > 160 ) {
				y += 20;
				dy -= 20*2;
			}

			setColor(pMe,255,255,255);
			initAnitext(pMe,pMe->menu_about,500,dx,GFX_HCENTER);
			drawAnitext(pMe,x,y,dx,dy);

			break;

		// ŷ  Ȯ â
		case MSTATE_PUTRANKINGCONFIRM:
			// draw menupan
			setClip(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy);
			menuDrawPan(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy,TRUE);


			setColor(pMe,255,255,255);
			x = pMe->canvas_midx;
			y = pMe->imgGame[IMG_TXTRANKING].info.cy;
			if(pMe->canvas_height < 130)		y += pMe->font_h/2;
			else if(pMe->canvas_height > 160)	y += pMe->font_h*2;
			else								y += pMe->font_h;

			drawString(pMe,"մϱ?",x,y,GFX_CENTER);	

			// draw lv and score
			y += pMe->font_h + 2;
			if( pMe->gPrevState == STATE_TRASH ) {
				SPRINTF(pMe->tempStr,"Lv:%d",pMe->endless_trashlv+1);
				drawString(pMe,pMe->tempStr,pMe->canvas_midx-30,y,GFX_LEFT);

				y += pMe->font_h;
				SPRINTF(pMe->tempStr,"Score:%d",pMe->endless_trashscore);
				drawString(pMe,pMe->tempStr,pMe->canvas_midx-30,y,GFX_LEFT);
			}
			else if( pMe->gPrevState == STATE_FIND ) {
				SPRINTF(pMe->tempStr,"Lv:%d",pMe->endless_findlv+1);
				drawString(pMe,pMe->tempStr,pMe->canvas_midx-30,y,GFX_LEFT);

				y += pMe->font_h;
				SPRINTF(pMe->tempStr,"Score:%d",pMe->endless_findscore);
				drawString(pMe,pMe->tempStr,pMe->canvas_midx-30,y,GFX_LEFT);
			}
			else if( pMe->gPrevState == STATE_DIG ) {
				SPRINTF(pMe->tempStr,"Lv:%d",pMe->endless_diglv+1);
				drawString(pMe,pMe->tempStr,pMe->canvas_midx-30,y,GFX_LEFT);

				y += pMe->font_h;
				SPRINTF(pMe->tempStr,"Score:%d",pMe->endless_digscore);
				drawString(pMe,pMe->tempStr,pMe->canvas_midx-30,y,GFX_LEFT);
			}


			// draw yes or no
			y	= pMe->canvas_height - pMe->imgGame[IMG_MINIPAN].info.cy;			
			if(pMe->canvas_height < 130)		y -= pMe->font_h*2;
			else if(pMe->canvas_height > 160)	y -= pMe->font_h*3;
			else								y -= pMe->font_h*2;
			drawString(pMe,"",x,y,GFX_CENTER);

			y	= pMe->canvas_height - pMe->imgGame[IMG_MINIPAN].info.cy;			
			if(pMe->canvas_height < 130)		y -= pMe->font_h;
			else if(pMe->canvas_height > 160)	y -= pMe->font_h*2;
			else								y -= pMe->font_h*1;
			drawString(pMe,"ƴϿ",x,y,GFX_CENTER);

			// erase area where menuhand already had been drawn.
			x -= 40;
			y = pMe->canvas_height - pMe->imgGame[IMG_MINIPAN].info.cy;
			if( pMe->menu_RankingCurr == 0 )
			{
				if(pMe->canvas_height < 130)		y -= pMe->font_h*2;
				else if(pMe->canvas_height > 160)	y -= pMe->font_h*3;
				else								y -= pMe->font_h*2;
			}
			else if( pMe->menu_RankingCurr == 1 )
			{
				if(pMe->canvas_height < 130)		y -= pMe->font_h;
				else if(pMe->canvas_height > 160)	y -= pMe->font_h*2;
				else								y -= pMe->font_h*1;
			}

			drawForkAni(pMe,y);	
			break;


		// ŷ  .
		case MSTATE_RANKINGTRANSFER:
			// draw menupan
			setClip(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy);
			menuDrawPan(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy,TRUE);

			setColor(pMe,255,255,255);
			drawString(pMe,"ŷ  ..",pMe->canvas_midx,pMe->canvas_midy,GFX_CENTER);
			break;


		// ŷ  
		case MSTATE_RANKINGERROR:
			// draw menupan
			setClip(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy);
			menuDrawPan(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy,TRUE);

			setColor(pMe,255,255,255);
			drawString(pMe,"ŷ  .",pMe->canvas_midx,pMe->canvas_midy-pMe->font_h,GFX_CENTER);
			drawString(pMe,"ٽ õ غ.",pMe->canvas_midx,pMe->canvas_midy,GFX_CENTER);
			break;

		// ŷ  
		case MSTATE_RANKINGEMERGENCY:
			// draw menupan
			setClip(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy);
			menuDrawPan(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy,TRUE);


			x = (pMe->canvas_height > 160) ? 35 : 0;
			y	= pMe->imgGame[IMG_TXTRANKING].info.cy;
			if(pMe->canvas_height > 160)	y += pMe->font_h*2 - 6;
			else							y += pMe->font_h/2;
			dx	= pMe->canvas_width;
			dy	= pMe->canvas_height - pMe->imgGame[IMG_TXTTUTORIAL].info.cy - pMe->imgGame[IMG_MINIPAN].info.cy;

			setColor(pMe,255,255,255);
			initText(pMe,pMe->ranking_emergency,dx,dy,GFX_LEFT);
			drawText(pMe,x,y,dx,dy,FALSE);
			break;

		// ŷ  Ȯ
		case MSTATE_RANKINGRESULT:
			// draw menupan
			setClip(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy);
			menuDrawPan(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy,TRUE);

			setColor(pMe,255,255,255);
			if( pMe->ranking_type == 0 ) // ŷ  ̾
			{
				drawString(pMe,"ŷ  Ϸ",pMe->canvas_midx,pMe->canvas_midy-pMe->font_h,GFX_CENTER);
			}
			else if( pMe->ranking_type == 1 ) // ŷ  Ȯ ̾
			{
				int i,end;

				x = (pMe->canvas_height > 160) ? 35 : 3;
				y = pMe->imgGame[IMG_TXTRANKING].info.cy;

				// print "Top Ranking"				
				if(pMe->canvas_height > 160)	y += pMe->font_h*2 - 6;
				else							y += pMe->font_h/2;				
				drawString(pMe,"Rank: Tel-Lv-Score",x,y,GFX_LEFT);
				
				end = pMe->ranking_dataCnt;
				if( pMe->canvas_height < 130 && end > 1)
					end = 1;
				else if( pMe->canvas_height < 160 && end > 3)
					end = 3;

				if( pMe->ranking_dataCnt != 0 )
				{
					for(i=0;i<end;i++)
					{
						y += pMe->font_h;
						SPRINTF(pMe->tempStr,"   %d: x%s-%d-%d",pMe->ranking_data[i].rank,&pMe->ranking_data[i].telnum[7],pMe->ranking_data[i].score1,pMe->ranking_data[i].score2);
						drawString(pMe,pMe->tempStr,x,y,GFX_LEFT);
					}
				}
				else
				{
					y += pMe->font_h;
					setColor(pMe,255,0,0);
					drawString(pMe,"  no data",x,y,GFX_LEFT);
					setColor(pMe,255,255,255);
				}

				// print "My Ranking"
				y += pMe->font_h;
				drawString(pMe,"My Ranking",x,y,GFX_LEFT);

				if( pMe->ranking_mydataCnt != 0 )
				{
					y += pMe->font_h;
					SPRINTF(pMe->tempStr,"   %d: x%s-%d-%d",pMe->ranking_mydata.rank,&pMe->ranking_mydata.telnum[7],pMe->ranking_mydata.score1,pMe->ranking_mydata.score2);
					setColor(pMe,255,0,0);
					drawString(pMe,pMe->tempStr,x,y,GFX_LEFT);
					setColor(pMe,255,255,255);
				}
				else 
				{
					y += pMe->font_h;
					setColor(pMe,255,0,0);
					drawString(pMe,"  no data",x,y,GFX_LEFT);
					setColor(pMe,255,255,255);
				}

			}
			break;


		// ŷ  Ȯ
		case MSTATE_GETRANKINGCONFIRM:
			// draw menupan
			setClip(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy);
			menuDrawPan(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy,TRUE);


			setColor(pMe,255,255,255);
			x = pMe->canvas_midx;
			y = pMe->imgGame[IMG_TXTRANKING].info.cy;
			if(pMe->canvas_height < 130)		y += pMe->font_h/2;
			else if(pMe->canvas_height > 160)	y += pMe->font_h*3;
			else								y += pMe->font_h;
			
			drawString(pMe,"ȭᰡ ΰ",x,y,GFX_CENTER);	y += pMe->font_h;
			drawString(pMe,"˴ϴ ",x,y,GFX_CENTER);	y += pMe->font_h;
			drawString(pMe,"ðڽϱ?  ",x,y,GFX_CENTER);

			y	= pMe->canvas_height - pMe->imgGame[IMG_MINIPAN].info.cy;
			if(pMe->canvas_height < 130)		y -= pMe->font_h*2;
			else if(pMe->canvas_height > 160)	y -= pMe->font_h*3;
			else								y -= pMe->font_h*2;
			drawString(pMe,"",x,y,GFX_CENTER);

			y	= pMe->canvas_height - pMe->imgGame[IMG_MINIPAN].info.cy;
			if(pMe->canvas_height < 130)		y -= pMe->font_h;
			else if(pMe->canvas_height > 160)	y -= pMe->font_h*2;
			else								y -= pMe->font_h*1;				
			drawString(pMe,"ƴϿ",x,y,GFX_CENTER);

			// erase area where menuhand already had been drawn.
			x -= 40;
			y = pMe->canvas_height - pMe->imgGame[IMG_MINIPAN].info.cy;
			if( pMe->menu_RankingCurr == 0 )
			{				
				if(pMe->canvas_height < 130)		y -= pMe->font_h*2;
				else if(pMe->canvas_height > 160)	y -= pMe->font_h*3;
				else								y -= pMe->font_h*2;
			}
			else if( pMe->menu_RankingCurr == 1 )
			{
				if(pMe->canvas_height < 130)		y -= pMe->font_h;
				else if(pMe->canvas_height > 160)	y -= pMe->font_h*2;
				else								y -= pMe->font_h*1;
			}

			drawForkAni(pMe,y);	
			break;

		// ŷ  
		case MSTATE_RANKINGSELECT:
			// draw menupan
			setClip(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy);
			menuDrawPan(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy,TRUE);

			gap = (pMe->canvas_height < 130) ? 20 : 25;
			x	= pMe->menu_panx + pMe->menu_pandx/2;

			setColor(pMe,255,255,255);
			y	= (pMe->menu_pany + pMe->menu_pandy)/2 - gap;
			drawString(pMe,"â",x,y,GFX_CENTER);

			y	= (pMe->menu_pany + pMe->menu_pandy)/2;
			drawString(pMe,"˿",x,y,GFX_CENTER);

			y	= (pMe->menu_pany + pMe->menu_pandy)/2 + gap;
			drawString(pMe,"ı",x,y,GFX_CENTER);


			// erase area where menuhand already had been drawn.
			x = x-40;
			if( pMe->menu_RankingSelectCurr == 0 )
				y	= (pMe->menu_pany + pMe->menu_pandy)/2 - gap;
			else if( pMe->menu_RankingSelectCurr == 1 )
				y	= (pMe->menu_pany + pMe->menu_pandy)/2;
			else if( pMe->menu_RankingSelectCurr == 2 )
				y	= (pMe->menu_pany + pMe->menu_pandy)/2 + gap;	

			drawForkAni(pMe,y);	
			break;

		// ̿
		case MSTATE_FEE:
			// draw menupan
			setClip(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy);
			menuDrawPan(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy,TRUE);

			x	= 0;
			y	= pMe->imgGame[IMG_TXTFEE].info.cy;
			dx	= pMe->canvas_width;
			dy	= pMe->canvas_height - pMe->imgGame[IMG_TXTFEE].info.cy - pMe->imgGame[IMG_MINIPAN].info.cy;

			// ȭ  
			if( pMe->canvas_height > 160 ) {
				y += 20;
				dy -= 20*2;
			}

			setColor(pMe,255,255,255);
			initText(pMe,pMe->fee_story,dx,dy,GFX_LEFT);
			drawText(pMe,x,y,dx,dy,FALSE);			
			break;

		// 
		case MSTATE_EXIT:
			break;


		// ߸޴.
		case MSTATE_GAMEMENU:
			// draw menupan
			setClip(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy);
			menuDrawPan(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy,TRUE);

			// draw menu text bg
			dx = pMe->imgGame[IMG_MINIPAN].info.cx;
			dy = pMe->imgGame[IMG_MINIPAN].info.cy;
			x = pMe->canvas_midx;
			y = dy/2;

			// ȭ  
			if( pMe->canvas_height > 160 ) {
				y += 20;
			}

			drawImage(pMe,IMG_MINIPAN,x,y,GFX_CENTER);
			drawImage(pMe,IMG_TXTMENU,x,y,GFX_CENTER);
			

			x	= pMe->menu_panx + pMe->menu_pandx/2;

			// ȭ  
			if( pMe->canvas_height < 160 )
				y = 0;
			else
				y = 30;

			setColor(pMe,255,255,255);
			y += pMe->imgGame[IMG_TXTINFO].info.cy + pMe->font_h/2;
			drawString(pMe,"ϱ",x,y,GFX_CENTER);
			y += (pMe->canvas_height < 130) ? pMe->font_h : (int)(pMe->font_h*1.5);
			drawString(pMe,"ȯ漳",x,y,GFX_CENTER);
			y += (pMe->canvas_height < 130) ? pMe->font_h : (int)(pMe->font_h*1.5);
			drawString(pMe,"",x,y,GFX_CENTER);
			y += (pMe->canvas_height < 130) ? pMe->font_h : (int)(pMe->font_h*1.5);
			drawString(pMe,"θ޴",x,y,GFX_CENTER);


			// erase area where menuhand already had been drawn.
			x = x-40;

			// ȭ  
			if( pMe->canvas_height < 160 )
				y = 0;
			else
				y = 30;

			y += pMe->imgGame[IMG_TXTINFO].info.cy + pMe->font_h/2 +				
				 pMe->menu_gamemenuCurr * ((pMe->canvas_height < 130) ? pMe->font_h : (int)(pMe->font_h*1.5));

			drawForkAni(pMe,y);	
/*

			// erase area where menuhand already had been drawn.
			x = x-50;
			y = pMe->menu_pany + pMe->menu_pandy/5 + pMe->menu_gamemenuCurr*(pMe->menu_pandy/4);
			dx= pMe->imgGame[IMG_MENUHAND].info.cx;
			dy= pMe->menu_pandy;

			setClip(pMe,x-dx/2,pMe->menu_pany+5,dx,pMe->menu_pandy-10);
			pMe->menu_panDraw = FALSE;
			menuDrawPan(pMe,pMe->menu_panx,pMe->menu_pany,pMe->menu_pandx,pMe->menu_pandy,FALSE);

			// draw hand
			drawImage(pMe,IMG_MENUHAND,x,y,GFX_CENTER);
*/
			break;

	}
}

void menuInit(CMoso* pMe)
{
	setupMenu(pMe,MSTATE_MAIN);
	gotoMenu(pMe,MSTATE_MAIN);

	pMe->menu_Ani = 0;
	pMe->menu_Prev = pMe->menu_Curr = 0;

	// calculate where texts will be drawn.
//	pMe->menu_panx	= 10;
//	pMe->menu_pany	= 20;
//	pMe->menu_pandx	= pMe->canvas_width - pMe->menu_panx*2;	
//	pMe->menu_pandy	= pMe->canvas_height - pMe->menu_pany*2;	

	pMe->menu_panx	= 0;
	pMe->menu_pany	= 0;
	pMe->menu_pandx	= pMe->canvas_width;	
	pMe->menu_pandy	= pMe->canvas_height;	
}

void gotoMenu(CMoso* pMe,byte state)
{
	pMe->menu_State		= state;
	
	pMe->text_Draw		= FALSE;
	pMe->menu_panDraw	= FALSE;
	
	
	if( state == MSTATE_MAIN )
	{
		pMe->menu_Start			= 0;
		pMe->menu_Special		= 0;
		pMe->menu_SpecialConfirm= 0;
		pMe->menu_SettingCurr	= 0;
		pMe->menu_InfoCurr		= 0;
		pMe->menu_Tutorial		= 0;
		pMe->menu_gamemenuCurr	= 0;
		pMe->menu_RankingCurr	= 0;
		pMe->menu_RankingSelectCurr = 0;
		pMe->menu_backDraw		= FALSE;	//  MSTATE_MAIN    ൵ ǰڴ. ߿ غ.
		pMe->menu_Gamemenu		= FALSE;
	}
	else if( state == MSTATE_GAMEMENU )
	{
		pMe->menu_Start			= 0;
		pMe->menu_Special		= 0;
		pMe->menu_SpecialConfirm= 0;
		pMe->menu_SettingCurr	= 0;
		pMe->menu_InfoCurr		= 0;
		pMe->menu_Tutorial		= 0;
//		pMe->menu_gamemenuCurr	= 0;	// ּ ó ϸ  ޴  ޴   Ѵ.
		pMe->menu_RankingCurr	= 0;
		pMe->menu_RankingSelectCurr = 0;
		pMe->menu_backDraw		= FALSE;	//  MSTATE_MAIN    ൵ ǰڴ. ߿ غ.
		pMe->menu_Gamemenu		= TRUE;
	}
}

void setupMenu(CMoso* pMe, byte state)
{
	switch(state)
	{
		case MSTATE_MAIN:	// θ޴
			addItem(pMe);	// ӽ
			addItem(pMe);	// 伣
			addItem(pMe);	// ȯ漳
			addItem(pMe);	// 
			addItem(pMe);	// ŷ
			addItem(pMe);	// ̿
			addItem(pMe);	// 
			break;
	}
}

void addItem(CMoso* pMe)
{
	++pMe->menu_Numitem;
}

void menuDrawItem(CMoso* pMe)
{
	int x,y,dx,dy;							// position of image will be drawn.
	int curr=0,prev,next,extra;				// curr,prev,next menu.
	int move,move_dx1,move_dx2,move_dx3;	// ̹ 󸶸ŭ  ΰ.
	int clip_x,clip_y,clip_dx,clip_dy;
	int height;
	int gap;

	// init variable	
	clip_dx		= 80;
	clip_dy		= 50;
	clip_x		= pMe->canvas_midx - clip_dx/2;
	clip_y		= pMe->canvas_midy - clip_dy/2;

	gap			= 70;
	height		= pMe->canvas_height - 90;



	move		= 0;
	move_dx1	= 20;
	move_dx2	= 10;
	move_dx3	= 30;
	

	// draw back ground area which menu image will draw.	
	setClip(pMe,clip_x,clip_y,clip_dx,clip_dy);
	pMe->menu_backDraw = FALSE;
	menuDrawBg(pMe);


	setScreen(pMe);

	// draw menu text bg
	dx = pMe->imgGame[IMG_MINIPAN].info.cx;
	dy = pMe->imgGame[IMG_MINIPAN].info.cy;
	x = pMe->canvas_midx;
	y = dy/2;

	// ȭ  
	if( pMe->canvas_height > 160 ) {
		y += 20;
	}
	drawImage(pMe,IMG_MINIPAN,x,y,GFX_CENTER);

	// draw menu text 
	drawImage(pMe,IMG_TXTMENU,x,y,GFX_CENTER);


	// draw left arrow
	x = 0;	y = pMe->canvas_midy;

	// ȭ  
	if( pMe->canvas_height > 160 ) {
		x += 10;
	}
	drawImage(pMe,IMG_LEFTARROW,x,y,GFX_LEFT|GFX_VCENTER);

	// draw right arrow
	x = pMe->canvas_width;	y = pMe->canvas_midy;

	// ȭ  
	if( pMe->canvas_height > 160 ) {
		x -= 10;
	}
	drawImage(pMe,IMG_RIGHTARROW,x,y,GFX_RIGHT|GFX_VCENTER);



	// draw menu animation 
	switch( pMe->menu_Ani )
	{
		case 0:

			y = pMe->canvas_midy;
			curr = pMe->menu_Curr;
			prev = (curr == 0) ? pMe->menu_Numitem-1 : curr-1; 
			next = (curr == pMe->menu_Numitem-1) ? 0 : curr+1;

			/* kbckbc
			// draw chain.
			setScreen(pMe);
			for(i=0;i<3;i++)
				drawImage(pMe,IMG_MENUCHAIN,i*80,y,GFX_CENTER);
*/
			
			// draw selected image.	
			x = pMe->canvas_midx;



			//setClip(pMe,x-dx/2,y-dy/2,dx,dy);
			setClip(pMe,clip_x,clip_y,clip_dx,clip_dy);
			drawImage(pMe,IMG_MENUSTORY+curr,x,y,GFX_CENTER);

			/*
			// draw prev image
			x = pMe->canvas_midx - gap;
			//setClip(pMe,x-18,y-18,36,36);
			setClip(pMe,x-dx,y-dy,dx,dy);
			drawImage(pMe,IMG_MENUSTORY+prev,x,y,GFX_CENTER);

			// draw next image
			x = pMe->canvas_midx + gap;
			//setClip(pMe,x-18,y-18,36,36);
			setClip(pMe,x-dx,y-dy,dx,dy);
			drawImage(pMe,IMG_MENUSTORY+next,x,y,GFX_CENTER);
  */

			break;

		case 1:
		case 2:
		case 3:
			if( pMe->menu_Ani == 0)
				break;
			if( pMe->menu_Ani == 1 )
				move = move_dx1 * pMe->menu_Direction;
			else if( pMe->menu_Ani == 2 )
				move = move_dx2 * pMe->menu_Direction;
			else if( pMe->menu_Ani == 3 )
				move = move_dx3 * pMe->menu_Direction;


			--pMe->menu_Ani;

			y = pMe->canvas_midy;
			curr = pMe->menu_Prev;
			prev = (curr == 0) ? pMe->menu_Numitem-1 : curr-1; 
			next = (curr == pMe->menu_Numitem-1) ? 0 : curr+1;


			/* kbckbc
			// draw chain
			setScreen(pMe);
			for(i=0;i<3;i++)
				drawImage(pMe,IMG_MENUCHAIN,i*80+move,y,GFX_CENTER);
				*/
			
			// draw selected image.	
			x = pMe->canvas_midx;			
			x += move;
			//setClip(pMe,x-dx/2,y-dy/2,dx,dy);
			setClip(pMe,clip_x,clip_y,clip_dx,clip_dy);

			drawImage(pMe,IMG_MENUSTORY+curr,x,y,GFX_CENTER);

			// draw prev image
			x = pMe->canvas_midx - gap;
			x += move;
			//setClip(pMe,x-dx/2,y-dy/2,dx,dy);
			setClip(pMe,clip_x,clip_y,clip_dx,clip_dy);
			drawImage(pMe,IMG_MENUSTORY+prev,x,y,GFX_CENTER);

			// draw next image
			x = pMe->canvas_midx + gap;
			x += move;
			//setClip(pMe,x-dx/2,y-dy/2,dx,dy);
			setClip(pMe,clip_x,clip_y,clip_dx,clip_dy);
			drawImage(pMe,IMG_MENUSTORY+next,x,y,GFX_CENTER);

			// if direction is right
			if( pMe->menu_Direction == -1 ) 
			{
				//  ޴ ˾ƿ´.
				extra = (next == pMe->menu_Numitem-1) ? 0 : next+1;

				x = pMe->canvas_midx + gap*2;
				x += move;
				//setClip(pMe,x-dx/2,y-dy/2,dx,dy);
				setClip(pMe,clip_x,clip_y,clip_dx,clip_dy);
				drawImage(pMe,IMG_MENUSTORY+extra,x,y,GFX_CENTER);
			}
			// if direction is left
			else if( pMe->menu_Direction == +1 )
			{
				//  ޴ ˾ƿ´.
				extra = (prev == 0) ? pMe->menu_Numitem-1 : prev-1;

				x = pMe->canvas_midx - gap*2;
				x += move;
				//setClip(pMe,x-dx/2,y-dy/2,dx,dy);
				setClip(pMe,clip_x,clip_y,clip_dx,clip_dy);
				drawImage(pMe,IMG_MENUSTORY+extra,x,y,GFX_CENTER);
			}
			break;
	}

	// draw selected text.
	dx = 110;
	dy = 30;
	x = pMe->canvas_midx;
	y = pMe->canvas_height - pMe->imgGame[IMG_TXTSTORYMODE].info.cy/2;


	// ȭ  
	if( pMe->canvas_height > 160 ) {
		y -= 20;
	}

	// redraw background which text will be drawn.
	setClip(pMe,x-dx/2,y-dy/2,dx,dy);
	pMe->menu_backDraw = FALSE;
	menuDrawBg(pMe);

	// draw text
	drawImage(pMe,IMG_TXTSTORYMODE+curr,x,y,GFX_CENTER);


	/*
	// draw selected number and dot.
	x = pMe->canvas_midx - 45;
	drawGNumber(pMe,curr+1,x,y,GNUM_TYPE1);
	*/
}

void menuDrawBg(CMoso* pMe)
{
	if( pMe->menu_backDraw == FALSE ) 
	{
		int i,j;
		int dx,dy;
		int nx,ny;

		dx = pMe->imgGame[IMG_STATUSBG].info.cx;
		dy = pMe->imgGame[IMG_STATUSBG].info.cy;

		nx = pMe->canvas_width / dx;
		ny = pMe->canvas_height / dy;

		for(i=0;i<=nx;++i)
			for(j=0;j<=ny;++j)
				drawImage(pMe,IMG_STATUSBG,i*dx,j*dy,GFX_LEFTTOP);

			
		drawImage(pMe,IMG_BIGPAN,pMe->canvas_midx,pMe->canvas_midy,GFX_CENTER);

		pMe->menu_backDraw = TRUE;
	}
}

void menuDrawPan(CMoso* pMe,int x,int y,int dx,int dy,boolean drawEdge)
{
	if( pMe->menu_panDraw == FALSE )
	{
		int i,j;
		int idx,idy;	// image dx, image dy
		int nx,ny;		// new position
		int nGap;
		int nTitleImg;

		idx = pMe->imgGame[IMG_STATUSBG].info.cx;
		idy = pMe->imgGame[IMG_STATUSBG].info.cy;

		nx = dx / idx;
		ny = dy / idy;

		for(i=0;i<=nx;++i)
			for(j=0;j<=ny;++j)
				drawImage(pMe,IMG_STATUSBG,x+i*idx,y+j*idy,GFX_LEFTTOP);



		switch( pMe->menu_State )
		{
			case MSTATE_STORYMODECONFIRM:
				nTitleImg = IMG_TXTSTORYMODE;
				break;
			case MSTATE_ENDLESSMODE:
			case MSTATE_ENDLESSMODECONFIRM:
				nTitleImg = IMG_TXTENDLESSMODE;
				break;
			case MSTATE_SETTING:
				nTitleImg = IMG_TXTSETTING;
				break;
			case MSTATE_INFO:
				nTitleImg = IMG_TXTINFO;
				break;
			case MSTATE_TUTORIAL:
			case MSTATE_TRASH:
			case MSTATE_FIND:
			case MSTATE_DIG:
				nTitleImg = IMG_TXTTUTORIAL;
				break;

			case MSTATE_PUTRANKINGCONFIRM:
			case MSTATE_GETRANKINGCONFIRM:
			case MSTATE_RANKINGSELECT:
			case MSTATE_RANKINGTRANSFER:
			case MSTATE_RANKINGERROR:
			case MSTATE_RANKINGEMERGENCY:
			case MSTATE_RANKINGRESULT:
				nTitleImg = IMG_TXTRANKING;
				break;
			case MSTATE_FEE:
				nTitleImg = IMG_TXTFEE;
				break;
			case MSTATE_EXIT:
				nTitleImg = IMG_TXTEXIT;
				break;
			case MSTATE_STORY:
				nTitleImg = IMG_TXTSTORY;
				break;
			case MSTATE_KEYHOWTO:
				nTitleImg = IMG_TXTKEYHOWTO;
				break;
			case MSTATE_ABOUT:
				nTitleImg = IMG_TXTABOUT;
				break;
			default:
				nTitleImg = -1;
				break;
		}

		nGap = 0;

		x = pMe->canvas_midx;
		y = nGap;

		// ȭ  
		if( pMe->canvas_height > 160 ) {
			y += 20;
		}
		// draw text
		if( nTitleImg != -1 )
			drawImage(pMe,nTitleImg,x,y,GFX_HCENTER|GFX_TOP);
		

		dy = pMe->imgGame[IMG_MINIPAN].info.cy;
		y = pMe->canvas_height - dy/2 - nGap;


		// ȭ  
		if( pMe->canvas_height > 160 ) {
			y -= 20;
		}

		dx = pMe->imgGame[IMG_MINIPAN].info.cx;

		x = pMe->canvas_midx - dx/2 - nGap;
		drawImage(pMe,IMG_LEFTARROW,x,y,GFX_RIGHT|GFX_VCENTER);

		x = pMe->canvas_midx + dx/2 + nGap;
		drawImage(pMe,IMG_RIGHTARROW,x,y,GFX_LEFT|GFX_VCENTER);

		x = pMe->canvas_midx;
		drawImage(pMe,IMG_MINIPAN,pMe->canvas_midx,y,GFX_CENTER);
		drawImage(pMe,IMG_TXTBACK,pMe->canvas_midx,y,GFX_CENTER);


		pMe->menu_panDraw = TRUE;
	}
}
