import java.io.*;
//import org.kwis.msp.lcdui.*;// 
//import org.kwis.msp.media.*;// 
//import org.kwis.msp.handset.BackLight;// 
import mmpp.media.*;

public class Device //implements SoundListener
{

	private MediaPlayer m_MediaPlayer = null;
	public Device()
	{
		m_MediaPlayer = new MediaPlayer();
	}

	public void StartVib(int timeout)
	{
			Vibration.start(3,timeout*100);
	}

	public void StopVib()
	{
		Vibration.stop();
	}
	
	public void PlaySound(String strLocation) 
	{		
		try
		{
			m_MediaPlayer.stop();
			m_MediaPlayer.setMediaLocation(strLocation);
			m_MediaPlayer.setPlayBackLoop(false); 
	   		m_MediaPlayer.start();
		}
		catch(IOException e)
		{
			System.out.println("playsound Error");
	    }
	}

	public void PlaySoundLoop(String strLocation) 
	{		
		try
		{
			m_MediaPlayer.stop();
			m_MediaPlayer.setMediaLocation(strLocation);
			m_MediaPlayer.setPlayBackLoop(true); 
	   		m_MediaPlayer.start();
		}
		catch(IOException e)
		{
		   	System.out.println("playsoundloop Error");
		}
	}

	public void StopSound()
	{
		try
		{
			m_MediaPlayer.stop();
		}
		catch(Exception e)
		{
			System.out.println("StopSound Error");
		}
	}

	public void SoundSet(int Vol)
	{			
		m_MediaPlayer.setVolumeLevel(""+Vol);
		
	}
}