import java.io.*;
import org.kwis.msp.lcdui.*;// 
import org.kwis.msp.media.*;// 
import org.kwis.msp.handset.BackLight;// 

public class Device //implements SoundListener
{
	private Clip m_Clip = null;
	private Player m_MediaPlayer = null;

	public void StartVib(int timeout)
	{
//		DeviceControl.startVibra(50, time);
		//if(mcard.OPTION_var[1] == 1)	
			Vibrator.on(3,timeout*100);
	}
	public void StopVib()
	{
//		DeviceControl.stopVibra();
		Vibrator.on(0,10);
	}
	
	public void PlaySound(String strLocation) 
	{		
		try
		{
		    InputStream is = getClass().getResourceAsStream(strLocation); 
			byte[] buffer = new byte[is.available()]; 
			is.read(buffer); 
			is.close(); 
			//Clip clip = new Clip("Yamaha_MA2", buffer); 
			StopSound();
			m_Clip = new Clip("Yamaha_MA2",buffer);
			m_MediaPlayer.play(m_Clip, false); 
		}
		catch(Exception e)
		{
	    	e.printStackTrace();
	    }
	}
	public void PlaySoundLoop(String strLocation) 
	{		
		try
		{
			InputStream is = getClass().getResourceAsStream(strLocation+".mmf"); 
			byte[] buffer = new byte[is.available()]; 
			is.read(buffer); //ۿ о ̱....
			is.close(); 
			//Clip clip = new Clip("Yamaha_MA2", buffer); 
			StopSound();
			m_Clip = new Clip("Yamaha_MA2", buffer);
			m_MediaPlayer.play(m_Clip, true); 
		}
		catch(Exception e)
		{
		   	e.printStackTrace();
		}
	}
	public void StopSound()
	{
		try
		{
			if(m_Clip!=null)
			{	
				System.out.println("stop!!!!!!");
				m_MediaPlayer.stop(m_Clip);
				m_Clip.clearData();
			}
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
	public static void SoundSet(int Vol)
	{			
		switch(Vol)
		{
			case 0:
				Volume.set(0);
			case 1:
				Volume.set(30);
				break;
			case 2:
				Volume.set(60);
				break;
			case 3:
				Volume.set(100);
				break;
		}
	}
}