#ifndef _GLOBAL_H_
#define _GLOBAL_H_


#define RGB(r,g,b)			MAKE_RGB(r,g,b)
#define LOGFILE "log.txt"

//#define TEST

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// state definitions
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// cheat key
// Ȱȭ - 0, Ȱȭ - 1
#define CHEAT_DIRECTLY_MENULOAD		0	// ޴ ε ٷ 
#define	CHEAT_SKIP_EPISODE			0	// Ǽҵ Ⱥ

#define CHEAT_STORY_STAGECLEAR		1	// 丮  ׳  : ƼŰ  ׳ Ѿ.
#define CHEAT_STORY_USEITEM			1	//   . 4-ð 5-帱 6-ź 7-
#define CHEAT_STORY_ONLYITEM		0	//  ۸ 

#define CHEAT_ENDLESS_LEVELJUMP		1	//    ѱ
#define CHEAT_DIG_GUARDSTOP			0	// ı  ȿ̰

#define	CHEAT_HIDERANKING			0	// ŷ ޴ 

#define CHEAT_ENDLESS_ONESECOND		10	// Ѹ ð   ŭ ,  0 ϶ ⺻̴.

// debug sound
//#define DEBUG_SOUND

// global game state
#define STATE_NOTHING		0
#define STATE_NAMO			1
#define STATE_DAUM			2
#define STATE_INTRO			3
#define STATE_MENULOAD		4
#define STATE_MENU			5
#define STATE_TRASH			6
#define STATE_FIND			7
#define STATE_DIG			8

#define	STATE_STARTDAY			11
#define	STATE_MORNINGEPISODE	33
#define	STATE_NIGHTEPISODE		34
#define	STATE_SELECT			12
#define STATE_DAILY				13



#define STATE_EPISODE		10
#define STATE_TUTORIAL		14
#define	STATE_ANISTORY		30	// PROLOGUE,HAPPYEND,BADEND  ⿡ ش(ANIMATION STORY)



// load state
#define LSTATE_NUMIMAGE		0
#define LSTATE_SOUND		1
#define LSTATE_GAMEIMAGE	2
#define LSTATE_GAMEIMAGE2	3


// menu state
#define MSTATE_MAIN					0	// θ޴
#define MSTATE_STORYMODECONFIRM		1	// 丮 - ӽ/̾ϱ 
#define	MSTATE_ENDLESSMODE			20	// Ѹ
#define	MSTATE_ENDLESSMODECONFIRM	21	// Ѹ - ϱ/̾ϱ
#define MSTATE_SETTING				4	// ȯ漳
#define MSTATE_INFO					5	// 


#define MSTATE_PUTRANKINGCONFIRM	71	// ŷ  Ȯ â.
#define MSTATE_GETRANKINGCONFIRM	72	// ŷ  Ȯ â.
#define MSTATE_RANKINGSELECT		73	// ŷ   â (  ŷ , â, ˿, ı ) 
#define MSTATE_RANKINGTRANSFER		74	// ŷ  
#define MSTATE_RANKINGERROR			75	// ŷ   
#define MSTATE_RANKINGEMERGENCY		76	// ŷ  
#define	MSTATE_RANKINGRESULT		77	// ŷ  Ȯ




#define MSTATE_TUTORIAL				30	//  .
#define MSTATE_TRASH				31
#define MSTATE_FIND					32
#define MSTATE_DIG					33


#define MSTATE_FEE					9	// ̿
#define MSTATE_EXIT					22	// 
#define MSTATE_EXITCONFIRM			10	//  Ȯ/ƴϿ
#define	MSTATE_STORY				14	// Ӽ
#define MSTATE_KEYHOWTO				15	// ۹
#define	MSTATE_ABOUT				16	// ӹ
#define MSTATE_GAMEMENU				17	//  ޴


// trash State
#define TSTATE_READY		0	//
#define TSTATE_START		1	//
#define TSTATE_RESULT		2	//
#define TSTATE_END			3


// find state
#define FSTATE_READY		0	//
#define FSTATE_START		1	//	show movement
#define FSTATE_INPUT		2	//	get answer from user
#define FSTATE_RESULT		3	//	show result
#define FSTATE_END			4	//	end


// dig state
#define DSTATE_READY		0	//
#define DSTATE_START		1	//	show movement
#define DSTATE_RESULT		2	//	show result
#define DSTATE_END			3	//	end


#define DSTATE_DRILLITEM	5	// drill item
#define DSTATE_BOMBITEM		6	



// prologue state


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// anchor values definitions
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define GFX_LEFT					0x00
#define GFX_HCENTER					0x01
#define GFX_RIGHT					0x02
#define GFX_TOP						0x04
#define GFX_VCENTER					0x08
#define GFX_BOTTOM					0x10
#define GFX_LEFTTOP					(GFX_LEFT | GFX_TOP)
#define GFX_CENTER					(GFX_HCENTER | GFX_VCENTER)


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// key definitions
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// key define
#define GKEY_NONE		0x00000000
#define GKEY_LEFT		0x00000001
#define GKEY_RIGHT		0x00000002
#define GKEY_UP			0x00000004
#define GKEY_DOWN		0x00000008
#define GKEY_FIRE		0x00000010
#define GKEY_CLEAR		0x00000020
#define GKEY_A			0x00000040
#define GKEY_B			0x00000080
#define GKEY_C			0x00000100
#define GKEY_SOFT1		0x00000200	// back
#define GKEY_SOFT2		0x00000400	// select
#define GKEY_SOFT3		0x00000800	// middle button
#define GKEY_0			0x00001000
#define GKEY_1			0x00002000
#define GKEY_2			0x00004000
#define GKEY_3			0x00008000
#define GKEY_4			0x00010000
#define GKEY_5			0x00020000
#define GKEY_6			0x00040000
#define GKEY_7			0x00080000
#define GKEY_8			0x00100000
#define GKEY_9			0x00200000
#define GKEY_POUND		0x00400000
#define GKEY_STAR		0x00800000

#define GKEY_SELECT		(GKEY_SOFT2 | GKEY_SOFT3 | GKEY_5)
#define GKEY_BACK		(GKEY_SOFT1)
#define GKEY_ANYKEY		(GKEY_SOFT1 | GKEY_SOFT2 | GKEY_SOFT3 | GKEY_5)
#define GKEY_DIRKEY		(GKEY_LEFT | GKEY_RIGHT | GKEY_UP | GKEY_DOWN)
#define GKEY_NUMBER		(GKEY_1 | GKEY_2 | GKEY_3 | GKEY_4 | GKEY_5 | GKEY_6 | GKEY_7 | GKEY_8 | GKEY_9)


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// billcom 
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//   ׽Ʈ  KTF_BILL_COMM  ϰ .
// Ŀ   ̰   ϰ ϸ ŷ  °  ȴ.( Ŷ °  .  socketε.)
// ٸ ŷ Ŀ 缭 ¥ Ƿ Ŀ  ޴° ȵ.
//  ŷ  ϸ鼭 ׽Ʈ ϸ .
// IEB_KTF_COM_Connect Լ  ڰ FALSE  Ȯ   TRUE  ׽Ʈ ݼ .
#define KTF_BILL_COMM

#define	HOST_IP_ADDRESS		"218.153.118.241"	// namo ranking server
#define HOST_PUTPORT 8181
#define HOST_GETPORT 8182


#define ISDIGIT(c)  ( (unsigned) ((c) - '0') < 10)
#define ISALNUM(c)  ( ISDIGIT(c) || ISALPHA(c) )
#define ISALPHA(c)  ( (unsigned) ( ((c)|32) - 'a') < 26 )


typedef struct _SENDSCORE_ {
	uint32			gameType;	// 0 : â , 1 : ˿, 2 : ı
	uint32			score1;
	uint32			score2;
} SENDSCORE; // 12 byte


typedef struct _SENDTYPE {
	int			gameType;
} SENDTYPE;	// 4 byte


typedef struct _RANKDATA {	
	uint32		rank;
	char		telnum[11];	
	uint32		score1;
	uint32		score2;	
} RANKDATA;

// ƽ  :  ->   ϱ   ٿ    .
typedef struct
{
	int     iSignature1;
	char    achContentsId[12];
	char    szChargNumber[12];
	char    szResv[12];
	uint32  uiLen;
	char    achSignature2[4];
} MACSHEADERPKT;


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// image resource id definitions
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// ̹ ߰.(EX. IDB_TEMP)
// 1. bar Ͽ ߰. IDB_TEMP
// 2. IMAGE_RES  ߰ IMG_TEMP
// 3. moso.c  pMe->resIDGame[IMG_TEMP] = IDB_TEMP; ̷ ߰
// 4. drawImage Լ IMG_TEMP  ڷ ѱ .

enum IMAGE_RES {

	// common images
	IMG_NUMBER1,		
	IMG_NUMBER2,
	IMG_NUMBER3,
	IMG_HYPHEN,
	IMG_GAUGEPONG,
	IMG_GAUGELEVEL,
	IMG_GAUGELEVELBG,
	IMG_STATUSBG,
	IMG_TIME,
	IMG_START,
	IMG_CALENDAR,
	IMG_CLOCK,
	IMG_POINT,
	IMG_PERCENT,
	IMG_TXTFAILURE,
	IMG_TXTSUCCESS,
	IMG_TXTDAY,
	IMG_TXTSKIP,
	IMG_TXTSCORE,
	IMG_TXTLV,
	IMG_TXTPOWERLV,
	IMG_TXTWEAPONLV,
	IMG_BIGPAN,
	IMG_MINIPAN,
	IMG_LEFTARROW,
	IMG_RIGHTARROW,
	IMG_GAUGELOADINGBG,
	IMG_GAUGELOADING,
	

	
	

	// menu images
	IMG_MENUSTORY,
	IMG_MENUENDLESS,
	IMG_MENUSETTING,
	IMG_MENUINFO,
	IMG_MENURANKING,
	IMG_MENUFEE,	
	IMG_MENUEXIT,	
	IMG_TXTSTORYMODE,
	IMG_TXTENDLESSMODE,
	IMG_TXTSETTING,
	IMG_TXTINFO,
	IMG_TXTRANKING,
	IMG_TXTFEE,	
	IMG_TXTEXIT,
	IMG_TXTMENU,
	IMG_TXTSTORY,
	IMG_TXTKEYHOWTO,
	IMG_TXTABOUT,
	IMG_TXTBACK,
	IMG_TXTTUTORIAL,
	IMG_MENUHAND,
	IMG_MENUON,
	IMG_MENUOFF,
	


	// trash images
	IMG_TRASHSON0,
	IMG_TRASHSON1,
	IMG_TRASHSON2,
	IMG_TRASHBUG1,
	IMG_TRASHBUG2,
	IMG_TRASHBUG3,
	IMG_TRASHWIN1,
	IMG_TRASHWIN2,
	IMG_TRASHWIN3,
	IMG_TRASHWIN4,
	IMG_TRASHBG,
	IMG_TRASHMINIWIN,
	IMG_TRASHMULTIPLY,
	IMG_TRASHPONG1,
	IMG_TRASHPONG2,





	// find
	IMG_FINDCHA1,
	IMG_FINDMINICHA1,
	IMG_FINDREMAINCHA,
	IMG_FINDCHECK,




	// dig images
	IMG_DIGBG,
	IMG_DIGCM,
	IMG_DIGDIG1,
	IMG_DIGDIG2,
	IMG_DIGWEAPON1_1,
	IMG_DIGWEAPON1_2,
	IMG_DIGWEAPON2_1,
	IMG_DIGWEAPON2_2,
	IMG_DIGWEAPON3_1,
	IMG_DIGWEAPON3_2,
	IMG_DIGWEAPON4_1,
	IMG_DIGWEAPON4_2,
	IMG_DIGWEAPON5_1,
	IMG_DIGWEAPON5_2,
	IMG_DIGPOSTER1,
	IMG_DIGPOSTER2,
	IMG_DIGPOSTER3,
	IMG_DIGPOSTER4,
	IMG_DIGPIECE1,
	IMG_DIGPIECE2,
	IMG_DIGZZZ,
	IMG_DIGGUARD1,
	IMG_DIGGUARD2,
	IMG_DIGGUARD3,
	IMG_DIGICON1P,
	IMG_DIGICONGUARD1,
	IMG_DIGICONGUARD2,
	IMG_DIGICONGUARD3,
	IMG_DIGSTONE,
	IMG_DIGCAUGHT1,
	IMG_DIGCAUGHT2,
	IMG_DIGWARNING,
	IMG_DIGICONBOMB1,
	IMG_DIGICONBOMB2,
	IMG_DIGICONITEM1,
	IMG_DIGICONITEM2,
	IMG_DIGICONITEM3,
	IMG_DIGICONITEM4,
	IMG_DIGTIMELOCK,



	// daily
	IMG_DAILYLV,
	IMG_DAILYPROGRESS,


	// box
	IMG_BOXVERT,
	IMG_BOXHORZ,
	IMG_BOXEDGELT,
	IMG_BOXEDGERT,
	IMG_BOXEDGELB,
	IMG_BOXEDGERB,

	// staff
	IMG_STAFFDAUM,
	IMG_STAFFLSW,
	IMG_STAFFSPARKDH,
	IMG_STAFFFRONTA,
	IMG_STAFFKBCKBC,
	IMG_STAFFKYH,
	IMG_STAFFNCH,

	// fork
	IMG_LFORK,
	IMG_RFORK,



	// 176   εϴ ̹.
	//  14.
	IMG_FINDBGLEFT,
	IMG_FINDBGRIGHT,
	IMG_FINDBGTOP,
	IMG_FINDBGBOTTOM,


	IMG_DIGBGBOTTOM1,
	IMG_DIGBGBOTTOM2,
	IMG_DIGBGTOP1,
	IMG_DIGBGTOP2,


	IMG_TRASHBGLEFT,
	IMG_TRASHBGLEFT1,
	IMG_TRASHBGRIGHT,
	IMG_TRASHBGRIGHT1,
	IMG_TRASHBGTOP,
	IMG_TRASHBGDOOR,






	NUM_GAMEIMG	
};

enum SOUND_RES {
	SND_TRASHCLEAN,
	SND_TRASHGLASS1,
	SND_TRASHGLASS2,
	SND_TRASHHO,
	SND_TRASHWATER,

	SND_DIGDIG,
	SND_DIGHIT,

	SND_FINDSELECT,

	SND_ITEMBOMB,
	SND_ITEMDRILL,

	SND_MENUMOVE,
	SND_MENUSELECT,	

	NUM_SOUND
};


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// sddata definitions
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// save data
enum {
	SD_CONFIG_SOUND,			// ޴_ ֳ
	SD_CONFIG_VIBRATION,		// ޴_ ֳ

	SD_STORY_DAY,				// 丮_°
	SD_STORY_STAGE,				// 丮_° ̳	
	SD_STORY_TRASHSTAGE,		// 丮_â °  ؾϳ
	SD_STORY_FINDSTAGE,			// 丮_˿ °  ؾϳ
	SD_STORY_POWER,				// 丮_ ȶҼ 󸶳
	SD_STORY_WEAPON,			// 丮_ ũ 󸶳

	SD_STORY_ITEMNUM,
	SD_STORY_ITEM1,
	SD_STORY_ITEM2,
	SD_STORY_ITEM3,
	SD_STORY_ITEM4,
	SD_STORY_ITEM5,
	SD_STORY_ITEM6,
	SD_STORY_ITEM7,
	SD_STORY_ITEM8,
	SD_STORY_ITEM9,
	SD_STORY_ITEM10,
	SD_STORY_ITEM11,
	SD_STORY_ITEM12,
	SD_STORY_ITEM13,
	SD_STORY_ITEM14,
	SD_STORY_ITEM15,
	SD_STORY_ITEM16,
	SD_STORY_ITEM17,
	SD_STORY_ITEM18,
	SD_STORY_ITEM19,
	SD_STORY_ITEM20,
	SD_STORY_ITEM21,
	SD_STORY_ITEM22,
	SD_STORY_ITEM23,
	SD_STORY_ITEM24,
	SD_STORY_ITEM25,
	SD_STORY_ITEM26,
	SD_STORY_ITEM27,
	SD_STORY_ITEM28,
	SD_STORY_ITEM29,
	SD_STORY_ITEM30,

	SD_ENDLESS_TRASHLV,			// Ѹ_â ۱  ̳
	SD_ENDLESS_FINDLV,			// Ѹ_ã  ̳
	SD_ENDLESS_DIGLV,			// Ѹ_ı  ̳
	NUM_SAVE			
};

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Image definitions
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Image structure
typedef struct _Bitmap_
{
	void*			src;
	void*			bitmap;
	AEEImageInfo	info;
} Image;



////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Gauge definitions
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define	GAUGE_HORZ		0
#define	GAUGE_VERT		1




////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// logo definitions
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// how long will be logo showed ?
#define LOGOSHOW		3000	// millisecond.
// number of menuitem
#define	NUM_MENUITEM		7	// 





////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// common definitions
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define STATUS_HEIGHT		23




////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// game
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//  ̴ϱ ʿ  Ƚϰ .
//#define GAME_DESTDEPTH		20	// 20 ܰ  ľ .
//#define GAME_DEADDAY		1	// 10  ĸ  ..
#define GAME_STORY_DAY		30	// 30    .
#define GAME_STORY_STAGE	20	// 20   ľ.


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Find definitions
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define FIND_STOP		0
#define FIND_MOVE		1
#define FIND_BLACK		2
#define	FIND_NUMRANDSEQ	5
//#define FIND_EXPGAP		15	// exp ׷ ġ Ȯ..

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Trash definitions
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define	TRASH_LEFTGAP		15

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Dig definitions
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define DIG_DISTANCE		10	// distance between 1p & guard
#define DIG_CAUGHTDIS		2	//  Ÿ..


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// episode definitions
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define	EPISODE_HEIGHT		60	// episode ȭâ  .
#define EPISODE_ANIMATION	4
#define EPISODE_LEFT		0
#define EPISODE_RIGHT		1


#define EPISODE1_NUMLINE	4	// episode ȭ .
#define EPISODE2_NUMLINE	6
#define EPISODE3_NUMLINE	4
#define EPISODE4_NUMLINE	4
#define EPISODE5_NUMLINE	7
#define EPISODE6_NUMLINE	6
#define EPISODE7_NUMLINE	6
#define EPISODE8_NUMLINE	5
#define EPISODE9_NUMLINE	5
#define EPISODE10_NUMLINE	1
#define EPISODE11_NUMLINE	1
#define EPISODE12_NUMLINE	1
#define EPISODE13_NUMLINE	1
#define EPISODE14_NUMLINE	1






////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// draw text definitions
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define TEXT_HORZMARGIN		7
#define TEXT_VERTMARGIN		2
#define TEXT_LINEFEED		'\\'
#define TEXT_PAGEFEED		'$'


#define GAMEMODE_STORY		0
#define GAMEMODE_ENDLESS	1




////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// level factor definitions
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define ENDLESS_LEVELEND	99	// Ѹ   Ѱ. 99  ķ .
#define ENDLESS_LEVEL		30

#define TRASH_WHOLETIME		0
#define TRASH_TRASHGAP		1
#define TRASH_PONGPONG		2
#define TRASH_WINDOW		3
#define TRASH_DESTSCORE		4
#define TRASH_NUMFACTOR		5


#define FIND_WHOLETIME		0
#define FIND_MOVEGAP		1
#define FIND_INPUTTIME		2
#define FIND_MOVEMAX		3
#define FIND_SPOTMAX		4
#define FIND_DESTSCORE		5
#define FIND_NUMFACTOR		6


#define DIG_WHOLETIME		0	//  ð.
#define DIG_GUARDNUM		1	//  .
#define DIG_GUARDGAP		2	//  ̴ ð .
#define DIG_DESTDIRT		3	// ľ .
#define DIG_NUMFACTOR		4


// happy mobile logo   3ܰ ani  ̷ ִ.	
#define HAPPYLOGO_STATE1	1	// happy mobile ۾   
#define HAPPYLOGO_STATE2	2	// ԰  .
#define HAPPYLOGO_STATE3	3	//    ׳(?) .
#define HAPPYLOGO_STATE4	4	// ani . ٸ STATE  Ѿ ܰ.

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// CMoso definitions
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _CMoso_
{
	AEEApplet	a;

	IHeap *pIHeap;


	// how much sec thread will going to sleep.
	int			waitTime;	
	
	// must set font and font_h. 
	// ex) font = AEE_FONT_BOLD, font_h = IDISPLAY_GetFontMetrics(pMe->a.m_pIDisplay,pMe->font,NULL,NULL); 
	AEEFont		font;
	int			font_h;	
	int			font_w;


	// clipping region. setClip funtion will change this value.
	AEERect		clipRect;

	// drawString funtion will allocate memory 
	// when print some string will use this value.
	char		tempStr[50];
	AECHAR		tempWStr[50];

	char*		main_story;

	char*		fee_story; //  ̿

	// lcd size info
	int		canvas_width;
	int		canvas_height;
	int		canvas_midx;
	int		canvas_midy;


	// random 
	byte		rand[200];
	int			randi;		// random index

	// images.
	Image		imgTemp;
	int			imgNum;					//   Ǵ ̹ . 176  ƴ   Ʋ.
	Image		imgGame[NUM_GAMEIMG];	//   Ǵ ̹.
	int			resIDGame[NUM_GAMEIMG];	


	// hold GAME STATE.
	byte		gState;
	byte		gPrevState;	// ߿ Ӹ޴  ư  .


	// if updateDisplay is true , redraw whole canvas.
	//boolean		updateDisplay;


	// checking interval time.
	uint32		startTime;
	uint32		endTime;



	boolean		gameMode;


	char*		vstr;	// version string

	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// socket
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	int				ranking_result;			// 0 : ŷ  , 1 : ŷ  , 2 :  
	int				ranking_type;			// 0 : ŷ , 1 : ŷ  Ȯ
	char			ranking_emergency[256];	//   .

	int				ranking_dataCnt;		// ŷ Ÿ 
	RANKDATA		ranking_data[5];		// ŷ Ÿ

	int				ranking_mydataCnt;		// my ranking 
	RANKDATA		ranking_mydata;			// my ranking Ÿ
	
	ISocket *		m_pISocket;
	INetMgr *		m_pINetMgr;	
	IEB_KTF_Com*	m_pBillcomMgr;
	
	int				readPos;
	int				readSize;
	char			readBuf[256];

	int				sendPos;
	int				sendSize;
	char			sendBuf[256];

	INAddr			nodeINAddr;


	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// ranking
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	

	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// story mode
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	boolean		story_2guard;
	boolean		story_3guard;

	int			story_day;			// *ϴ *  °?
	int			story_stage;		// *ϴ *  ° ? (  20  )	
	int			story_trashstage;	// *ϴ * â  .  15  ְ  ̻  
	int			story_findstage;	// *ϴ * ˿  .  15  ְ  ̻  
	int			story_power;		// *ϴ * ȶ  ?
	int			story_weapon;		// *ϴ * ũ  ?
		
	
	//   ִ . ִ 30    ִ. 
	//    İ 30  .  ̷ ְڳ.
	int			story_itemNum;		//    ֳ.
	int			story_item[GAME_STORY_DAY];	


//	int			story_trashFactor[ENDLESS_LEVEL][TRASH_NUMFACTOR];
//	int			story_findFactor[ENDLESS_LEVEL][FIND_NUMFACTOR];

	int			story_trashFactor[15][TRASH_NUMFACTOR];
	int			story_findFactor[15][FIND_NUMFACTOR];


	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// endless mode
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	int			endless_trashlv;
	int			endless_findlv;
	int			endless_diglv;

	int			endless_trashscore;
	int			endless_findscore;
	int			endless_digscore;

	int			endless_trashFactor[ENDLESS_LEVEL][TRASH_NUMFACTOR];
	int			endless_findFactor[ENDLESS_LEVEL][FIND_NUMFACTOR];
	int			endless_digFactor[GAME_STORY_STAGE][DIG_NUMFACTOR];


	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// loadTick() & loadDraw() 
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// how many resources have read.
	int		numResource;
	int		currRead;
	int		totalRead;

	boolean	load_backDraw;

	Image	imgLoading;
	Image	imgLoadbar;
	Image	imgLoadbarBg;
	Image	imgLoadBg;


	

	// when read resources use this flag.
	byte		loadState;




	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// menuTick() & menuDraw() 
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	byte		menu_State;
	int			menu_Curr;
	int			menu_Prev;
	int			menu_Numitem;	// number of added item.
	byte		menu_Ani;		// frame of animation
	int			menu_Direction;	// +1 : left , -1 : right
	boolean		menu_backDraw;	// redraw menu bg or not.
	boolean		menu_panDraw;	// redraw menupan or not.
	boolean		menu_Gamemenu;	// Ӹ޴ ƴ Ǻ..


	// menupan position
	int		menu_panx;
	int		menu_pany;
	int		menu_pandx;
	int		menu_pandy;


	int		menu_Start;			// ϱ/̾ϱ ִ 
	int		menu_Special;		// ı/â/˿ ִ 
	int		menu_SpecialConfirm;// Ѹ - ϱ/̾ϱ  ִ 
	int		menu_SettingCurr;	// //ӵ ִ 
	int		menu_InfoCurr;		// 丮/۹/ӹ ִ 
	int		menu_Tutorial;		// Ӽ - â/˿/ձ  ִ .
	int		menu_gamemenuCurr;	//  ޴ ϱ/ȯ漳//θ޴  ִ 
	int		menu_RankingCurr;	// /ƴϿ
	int		menu_RankingSelectCurr; // ŷ â/˿/ı    ִ 

	Image	menu_imgKeyInfo;	// Ű      ̹.


	char	menu_about[300];


	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// key input
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	// hold key input.
	// key : just hold the input value.
	// keyCurr : м  Ű . GKEY_XXX value 
	uint32		key;
	uint32		keyCurr;

	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// sound
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	AEEDeviceInfo	dm;

	// From Device
	AEESoundInfo	soundInfo;	
	ISound*			m_pISound;
	ISoundPlayer*	soundPlayer;
	byte*			soundClip;

	boolean			soundPlaying;

	int				sndID[NUM_SOUND];

	int				soundId;	
	boolean			soundRepeat;

	int				soundPendingId;
	boolean			soundPendingRepeat;

	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// config
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	boolean			config_isSound;		// 
	boolean			config_isVibration;	// 


	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// save data
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
	byte		sd[NUM_SAVE];		// save data.
	IFileMgr*	fileMgr;



	


	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// common variable :  ̴ϰӿ   
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////





	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// trash 
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	boolean		trash_redraw;

	boolean		trash_backDraw;
	byte		trash_state;
	uint32		trash_wholeTime;	//   ð.
	uint32		trash_startTime;	//  ó  ð.
	uint32		trash_currTime;		//   ð.
	uint32		trash_trashStart;	//  ó ߻ ð..
	uint32		trash_trashGap;		//  ߻ϴ ð .
	uint32		trash_temp;			// ð   .


	int			trash_currScore;
	int			trash_destScore;
	

	int			trash_x[9];			// position.
	int			trash_y[9];			//
	
	byte		trash_window[9];	// â .
	byte		trash_hole[9];		//  ġ

	int			trash_maxPong;		
	int			trash_currPong;		//   .
	int			trash_handCurr;		// hand position
	int			trash_handPrev;		// hand position
	int			trash_AniCurr;		//  ġ(animation)
	int			trash_AniPrev;		//  ġ(animation)



	int			trash_pongAni;		//    ִ ִϸ̼..


	boolean		trash_ready;		// ready   ð   .
	int			trash_startAni;		// start ִϸ̼   
	boolean		trash_end;			// end   ð   .
	

	//  ̹ &  ġ
	int			trash_pong_x;
	int			trash_pong_y;
	int			trash_pongbar_x;
	int			trash_pongbar_y;


	// STATUS BAR ġ .
	int			trash_status_x;
	int			trash_status_y;

	int			trash_window_x;
	int			trash_window_y;
	int			trash_multiply_x;
	int			trash_multiply_y;
	int			trash_remain_x;
	int			trash_remain_y;

	int			trash_time_x;
	int			trash_time_y;
	int			trash_clock_x;
	int			trash_clock_y;
	int			trash_point_x;
	int			trash_point_y;


	int			trash_calendar_x;
	int			trash_calendar_y;
	int			trash_day_x;
	int			trash_day_y;
	int			trash_lv_x;
	int			trash_lv_y;

	// result  ġ 
	boolean		trash_resultbackDraw;
	int			trash_resultup_x;
	int			trash_resultup_y;
	int			trash_resultup_dx;
	int			trash_resultup_dy;
	int			trash_resultdn_x;
	int			trash_resultdn_y;
	int			trash_resultdn_dx;
	int			trash_resultdn_dy;

	
	uint32		trash_cleanGap;
	
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// find
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	boolean		find_backDraw;
	byte		find_state;

	uint32		find_wholeTime;	//   ð.
	uint32		find_startTime;	//  ó  ð.
	uint32		find_currTime;	//   ð.
	uint32		find_gameGap;	// Ӱ   ð.
	uint32		find_moveGap;	//  ߻ϴ ð .
	uint32		find_inputTime;	//  Է ð..
	uint32		find_temp;		// ð   ϴ 


	

	boolean		find_ready;		// ready ִϸ̼    ð °  ˸.
	int			find_startAni;	// start ִϸ̼   
	boolean		find_input;		// input Ҷ Էϴ ð °  ˸.
	boolean		find_end;		// end ִϸ̼    ð °  ˸.
	


	boolean		find_moveMax;	//   ΰ.
	boolean		find_move[9];	//   ΰ...
	boolean		find_moved;		// ˼   Ǿ..
	boolean		find_moveOnce;	// ˼ ѹ ٸ ٽ  ׷ָ ȴ.


	int			find_seqFlag;	
	int			find_seq[FIND_NUMRANDSEQ][9];	// ˼ ̴   



	// ߿ spot Ʈ   迭 ִ ŭ Ʈ.
	int		find_spotMax;		// ÿ    ִ ִ 
	int		find_spotFlag;	
	int		find_spot[9];		//     ΰ...
	int		find_accumulFlag;	// spot     ִ 

	int		find_iter;			// ° find_spot 迭  ֳ..
	int		find_spotStart;		// spot ޴ 
	int		find_spotEnd;		// spot  

	

	int		find_right;			// Է  ..
	int		find_currScore;		//  .
	int		find_destScore;		// ǥ .



	int		find_x[9];		// position
	int		find_y[9];


	boolean find_answer;

	//   ׷ ̹ ġ
	int		find_remaincha_x;
	int		find_remaincha_y;

	// ġ ġ
	int		find_ex_x;
	int		find_ex_y;
	int		find_exval_x;
	int		find_exval_y;


	// STATUS BAR ġ .
	int		find_status_x;
	int		find_status_y;

	int		find_window_x;
	int		find_window_y;
	int		find_multiply_x;
	int		find_multiply_y;
	int		find_remain_x;
	int		find_remain_y;

	int		find_time_x;
	int		find_time_y;
	int		find_clock_x;
	int		find_clock_y;
	int		find_point_x;
	int		find_point_y;


	int		find_calendar_x;
	int		find_calendar_y;
	int		find_day_x;
	int		find_day_y;
	int		find_lv_x;
	int		find_lv_y;

	// result  ġ 
	boolean	find_resultbackDraw;
	int		find_resultup_x;
	int		find_resultup_y;
	int		find_resultup_dx;
	int		find_resultup_dy;
	int		find_resultdn_x;
	int		find_resultdn_y;
	int		find_resultdn_dx;
	int		find_resultdn_dy;


	// ڰ    Է Ͽ 
	// ׷ٸ   Ű ޾Ҵ   ʴ´.
	boolean	find_cutInput;	
	int		find_keyPrev;	// ڰ ߿ ԷϿٸ ⿡ٰ Ű  س´.

	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// dig
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	boolean		dig_backDraw;
	byte		dig_state;

	uint32		dig_wholeTime;
	uint32		dig_startTime;	
	uint32		dig_currTime;	//   ð.
	
	uint32		dig_caughtTime;	//   ð  .
	boolean		dig_caught;		//  ƴ 

	uint32		dig_guardStart;	//   ð    .
	uint32		dig_guardGap;	//   ð ...


	int			dig_ani1P;		//  Ĵ ִϸ̼


	uint32		dig_temp;		// READY   ð  .


	boolean		dig_ready;	
	int			dig_startAni;	// start ִϸ̼   
	boolean		dig_end;



	boolean		dig_sleepsndPlayed;
	boolean		dig_hitsndPlay1;
	boolean		dig_hitsndPlay2;



	// ð 
	boolean		dig_timeUsed;		// ð  質?
	uint32		dig_timeTime;		// ð .

	// 帱 
	boolean		dig_drillUsed;		// 帱  .
	int			dig_drillFrame;		//   ִϸ̼.
	int			dig_drillAni;		// ĳ ٲ  ִϸ̼.
	int			dig_drillPoster;	// 帱    µ   ġ   ֱ
	int			dig_drillOneshot;	// 帱 ѹ   ĳ .

	// ź 
	boolean		dig_bombUsed;		// ź  質.
	uint32		dig_bombTime;		// ð .
	int			dig_bombFrame;		// ź  ִϸ̼
	
	
	boolean		dig_bombSound;




	//  ġ ..
	int		dig_numGuard;			//  ΰ..
	int		dig_positionGuard[3];	//  ġ.
	int		dig_directionGuard[3];	// left : right
	int		dig_frequent[3];		//  ٲٴ 󵵼.


	// 
	int		dig_destDirt;		//  ľ ϴ .
	int		dig_currDirt;		//  ĳ  
	int		dig_positionPoster;		// 0 : , 1 : , 2 : , 3 :  
	int		dig_directionPoster;



	// 1p  poster ġ.
	int		dig_1p_x;
	int		dig_1p_y;
	int		dig_poster_x;
	int		dig_poster_y;

	int		dig_cm_x;
	int		dig_cm_y;

	int		dig_guard_x;
	int		dig_guard_y;



	// STATUS BAR ġ .
	int		dig_status_x;
	int		dig_status_y;

	int		dig_stone_x;
	int		dig_stone_y;
	int		dig_remain_x;
	int		dig_remain_y;

	int		dig_percent_x;	
	int		dig_percent_y;

	int		dig_time_x;
	int		dig_time_y;
	int		dig_clock_x;
	int		dig_clock_y;
	int		dig_point_x;
	int		dig_point_y;


	int		dig_calendar_x;
	int		dig_calendar_y;
	int		dig_day_x;
	int		dig_day_y;
	int		dig_lv_x;
	int		dig_lv_y;



	//  Ƣ  ׸.
	int		dig_framePiece;
	boolean	dig_whichPiece;

	//   ̴° ׸.
	int		dig_frameMinus;

	//      ̹.
	int		dig_frameWarning;


	int		dig_oneShot;	// ѹ     . power  weapon   Ѵ. 


	uint32	dig_digGap;
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// gauge
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	//  ִ  ȭ鿡 3   ִ.
	int		gauge_flag;

	int		gauge_x[3];
	int		gauge_y[3];	
	int		gauge_width[3];
	int		gauge_height[3];
	int		gauge_d[3];			// direction
	int		gauge_max[3];
	int		gauge_resId[3];
	int		gauge_resbgId[3];



	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// startday
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	boolean	startday_init;



	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// anistory
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	boolean	anistory_backDraw;
	int		anistory_type;
	int		anistory_img;
	char*	anistory_story;


	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// initText, drawText, stopText
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	boolean		text_Draw;
	boolean		text_init;		// whether start drawing text or not.
	boolean		text_reachEnd;	// ȭ  ߴٸ..
	AECHAR*		text_mbText;
	int			text_vgap;
	int			text_currpage;
	int			text_wholepage;	
	int			text_wholeline;	
	int			text_lineperpage;	
	int			text_align;

	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// initAniText, drawAnitextdrawText, stopText
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	boolean		anitext_init;		// whether start drawing text or not.

	uint32		anitext_timegap;	// 󸶳  ȭ ø.
	uint32		anitext_startTime;	// ð  
	int			anitext_y;			// ũ Ǵ y  
	int			anitext_frame;		// ִϸ̼  Ǿ...


	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// episode
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	boolean	episode_backDraw;

	boolean	episode_init;		// episode ʱȭ ߳ ߳..
	int		episode_Direction;	// ȭ ϴ  .. ̳ ̳..

	Image	episode_leftImage;
	Image	episode_rightImage;
	Image	episode_bgImage;

	int		episode_ani;
	int		episode_line;
	int		episode_lineNum;
	boolean	episode_left;
	char**	episode_text;

	char*	episode_caption1[EPISODE1_NUMLINE];	// episode #1
	char*	episode_caption2[EPISODE2_NUMLINE]; // episode #2
	char*	episode_caption3[EPISODE3_NUMLINE];	// episode #3
	char*	episode_caption4[EPISODE4_NUMLINE]; // episode #4
	char*	episode_caption5[EPISODE5_NUMLINE];	// episode #5
	char*	episode_caption6[EPISODE6_NUMLINE]; // episode #6
	char*	episode_caption7[EPISODE7_NUMLINE]; // episode #7
	char*	episode_caption8[EPISODE8_NUMLINE]; // episode #8
	char*	episode_caption9[EPISODE9_NUMLINE]; // episode #9
	char*	episode_caption10[EPISODE10_NUMLINE]; // episode #10
	char*	episode_caption11[EPISODE11_NUMLINE]; // episode #11
	char*	episode_caption12[EPISODE12_NUMLINE]; // episode #12
	char*	episode_caption13[EPISODE13_NUMLINE]; // episode #13
	char*	episode_caption14[EPISODE14_NUMLINE]; // episode #14

	int		episode_leftstep;	//  ̹ ѹ ̴ Ÿ.
	int		episode_rightstep;	//  ̹ ѹ ̴ Ÿ.


	int		episode_left_x;
	int		episode_left_y;
	int		episode_right_x;
	int		episode_right_y;
	int		episode_dx;
	int		episode_dy;


	boolean	episode_showed;


	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// tutorial
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	char*	tutorial_trashstory;
	char*	tutorial_findstory;
	char*	tutorial_digstory;

	boolean	tutorial_backDraw;

	boolean	tutorial_trashShowed;
	boolean	tutorial_findShowed;
	boolean	tutorial_digShowed;


	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// daily
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	boolean	daily_backDraw;


	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// select 
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	// 0:Power,1:Weapon,2:Item
	int		select_game1;	// 0,1,2  ϳ  ִ.
	int		select_game2;	// 0,1,2  ϳ  ִ.
	int		select_mission;	// 0 ̸ õ mission  POWER ̰ 1 ̸ õ mission  WEAPON ̴.
	boolean	select_select;	// 0 ̸ â  1 ̸ ˿ 
	boolean	select_backDraw;



	int select_title_x,select_title_y;
	int	select_trash_x,select_trash_y;
	int	select_find_x,select_find_y;
	int	select_str1_x,select_str1_y;
	int	select_str2_x,select_str2_y;


	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// debug sound
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	int		eCBType;
	int		eStatus;
	char	DEBUG[20];


	// ũ ִ  
	long	forkTime;	
	int		menuHand;


	// =================================================================================	
	// Happy Mobile logo  
	// =================================================================================	

	Image			imgHappyLogo1;
	Image			imgHappyLogo2;
	Image			imgHappyLogo3;
	Image			imgHappyLogo4;
	Image			imgHappyLogo5;

	int				logoState;


	int				logoFrame;
	uint32			logoTimeGap;
	int				logoState1Frame;
	int				logoState2Frame;
	int				logoState3Frame;
	int				logoHeight;
	// =================================================================================	



} CMoso;

#endif	// _GLOBAL_H_
