#ifndef _MOSO_H_
#define _MOSO_H_

#include <AEEStdLib.h>
#include <AEEAppGen.h>
#include <AEEModGen.h>
#include <AEEFile.h>
#include <AEEDB.h>
#include <AEENet.h>
#include <AEEHeap.h>

// billcom
#include "IEB_KTF_BillCom.h"
#include "IEB_KTF_DM.h"
#include "IEB_KTF_PIMS.h"
#include "IEB_KTF_PPPID.h"
#include "IEB_KTF_SERIAL.h"
#include "IEB_KTF_THEME.h"
#include "IEB_KTF_UserInfo.h"
#include "IEB_KTF_VOICE.h"




#include "MOKJANG.BID"
#include "moso_res.h"
#include "global.h"
#include "common.h"


// Function Prototype.
void		moso_FreeAppData(IApplet *pi);
void		moso_InitAppData(IApplet *pi);
boolean		moso_HandleEvent(IApplet * pi, AEEEvent eCode, uint16 wParam, uint32 dwParam);

void		run(CMoso* pMe);
void		keyEvent(CMoso* pMe, uint16 key);
void		mosoTick(CMoso* pMe);
void		mosoDraw(CMoso* pMe);
void		moso_init(CMoso* pMe);


void		updateKey(CMoso* pMe);


void		SETSTATE(CMoso* pMe,byte state);


void		namoTick(CMoso* pMe);
void		namoDraw(CMoso* pMe);
void		daumTick(CMoso* pMe);
void		daumDraw(CMoso* pMe);
void		introTick(CMoso* pMe);
void		introDraw(CMoso* pMe);
void		menuloadTick(CMoso* pMe);
void		menuloadDraw(CMoso* pMe);



void		anistoryTick(CMoso* pMe);
void		anistoryDraw(CMoso* pMe);
//void		prologueTick(CMoso* pMe);
//void		prologueDraw(CMoso* pMe);



void		morningepisodeTick(CMoso* pMe);
void		morningepisodeDraw(CMoso* pMe);
void		nightepisodeTick(CMoso* pMe);
void		nightepisodeDraw(CMoso* pMe);

void		episodeTick(CMoso* pMe);
void		episodeInit(CMoso* pMe,int episode);
void		episodeDraw(CMoso* pMe);
void		episodeDrawBg(CMoso* pMe);
void		episodeEnd(CMoso* pMe);



void		startdayTick(CMoso* pMe);
void		startdayDraw(CMoso* pMe);

void		selectInit(CMoso* pMe);
void		selectTick(CMoso* pMe);
void		selectDraw(CMoso* pMe);

void		dailyTick(CMoso* pMe);
void		dailyDraw(CMoso* pMe);

void		tutorialTick(CMoso* pMe);
void		tutorialDraw(CMoso* pMe);
void		tutorialDrawBg(CMoso* pMe);

void		drawForkAni(CMoso* pMe,int y);
//void		happyTick(CMoso* pMe);
//void		happyDraw(CMoso* pMe);

//void		badTick(CMoso* pMe);
//void		badDraw(CMoso* pMe);


//==============================================
#endif	// _MOSO_H_