#ifndef _PNG2BMP_H_
#define _PNG2BMP_H_

#include <AEEStdLib.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifdef _DEBUG
# pragma comment(linker, "/nodefaultlib:libcmt.lib")
#endif

	void* PNG2BMP_LoadResData(IShell *pIShell, const char* pszResFile, int16 nResID);
	void* PNG2BMP_Convert(const void *buf_png);

#ifdef __cplusplus
}
#endif

#define png2bmp(buf_png)			PNG2BMP_Convert(buf_png)
#define PNG2BMP_FreeResData(pData)	FREE(pData)

#endif
